DECLARE SUB Reverse (St$)
DECLARE FUNCTION STRIP$ (St$)
DECLARE SUB ScrollUp (Row AS INTEGER, Col AS INTEGER, Rows AS INTEGER, Cols AS INTEGER, Attr AS INTEGER, HowMany AS INTEGER)
DECLARE SUB ScrollDown (Row AS INTEGER, Col AS INTEGER, Rows AS INTEGER, Cols AS INTEGER, Attr AS INTEGER, HowMany AS INTEGER)
DECLARE SUB QATTR (Row AS INTEGER, Col AS INTEGER, Rows AS INTEGER, Cols AS INTEGER, Attr AS INTEGER)
DECLARE SUB QPRINT (Text AS STRING, Row AS INTEGER, Col AS INTEGER, Attr AS INTEGER)
DECLARE FUNCTION SelectButton$ (ButtonRow%, ButtonCol%, SysKnopRij%, SysKnopKol%, ButtonType%, MRij%, MKol%, Toets%)
DECLARE FUNCTION UserInput% (MRij%, MKol%, Shift%, Ctrl%, Alt%, ErUitNa!)
DECLARE SUB Compress (St$)
DECLARE FUNCTION EditString$ (InString$, Legal$, Length%, Rest$, Visible%, HotKey%, Shift%, Ctrl%, Alt%, Gewijzigd%, Attr%, CurPos%, SelP%)
DECLARE SUB Button (Row%, Col%, Text$, Ingedrukt%, Default%)
DECLARE SUB HelpWindow (TpcNum%)
DECLARE SUB Expand (St$)
DECLARE SUB Panel (Row%, Col%, Hght%, Wdth%, Brdr%, Attr%)
DECLARE SUB OpenWin (Row%, Col%, Hght%, Wdth%, Attr%, Brdr%, Shdw%, Label%, Lbl$, Array%())
DECLARE SUB CloseWin (Array%())
DECLARE FUNCTION MSGBox$ (Msg$, ButtonType%, Title$, HelpTpcNum%)
DECLARE FUNCTION InputBox$ (Title$, Msg$, InString$, Legal$, Length%, Visible%, HotKey%, HelpTpcNum%)
DECLARE SUB ClipBoard (Which%, Buffer$)
DEFINT A-Z
'PBCLONE
DECLARE SUB Blink (BYVAL SetBlink%)
DECLARE SUB CursorInfo (Visible%, StartLine%, EndLine%, MaxLine%)
DECLARE SUB DelayV (BYVAL MilliSeconds%)
DECLARE SUB DRecDel (BYVAL DSeg%, BYVAL DOfs%, BYVAL RecNum%, BYVAL RecLen%, BYVAL TotalRecs%)
DECLARE SUB DRecIns (BYVAL DSeg%, BYVAL DOfs%, BYVAL RecNum%, BYVAL RecLen%, BYVAL TotalRecs%)
DECLARE FUNCTION Exist2% (FileName$)
DECLARE SUB Extract (St$, Delimiter$, Index%, Start%, SLen%)
DECLARE SUB FileCount (File$, BYVAL FilAttr%, FilCount%, ErrCode%)
DECLARE FUNCTION GetDrive$ ()
DECLARE SUB GetScreen (Array%(), BYVAL TopRow%, BYVAL LeftCol%, BYVAL BotRow%, BYVAL RtCol%, BYVAL Page%, BYVAL Fast%)
DECLARE SUB PutScreen (Array%(), BYVAL TopRow%, BYVAL LeftCol%, BYVAL BotRow%, BYVAL RCol%, BYVAL Page%, BYVAL Fast%)
DECLARE SUB GetKbd (Ins%, Caps%, Num%, ScrollLock%)
DECLARE SUB GetKbd1 (LShift%, RShift%, Control%, Alt%)
DECLARE SUB GetMouseLoc (Row%, Column%)
DECLARE FUNCTION GetSub2$ (Drive$)
DECLARE FUNCTION GetVGA2% ()
DECLARE SUB LoadDir (File$, BYVAL FilAttr%, BYVAL DSeg%, BYVAL DOfs%, ErrCode%)
DECLARE SUB MMButton (LeftB%, RightB%)
DECLARE SUB MMCursorOff ()
DECLARE SUB MMCursorOn ()
DECLARE SUB RInstr (MainSt$, SubSt$, Posn%)
DECLARE SUB SetBit (Number%, BYVAL BitNr%)
DECLARE SUB SetDrv (Drive$)
DECLARE SUB SetSub (SubDir$, ErrCode%)
DECLARE FUNCTION SubExist2% (SubDir$)
DECLARE SUB XLate (St$, TranslationTable$)
TYPE InitVars
    Rijen AS INTEGER
    Muis AS INTEGER
    AutoSave AS INTEGER
    Pieptoon AS INTEGER
    Schaduw AS INTEGER
    BeeldAfTijd AS INTEGER
    TekstSnel AS INTEGER
    RegelsAutomatisch AS INTEGER
END TYPE
DIM Kleur(1 TO 19)
COMMON SHARED Kleur()
COMMON SHARED In AS InitVars, HelpFile$

SUB Button (Row, Col, Text$, Ingedrukt, Default)
    IF Text$ <> "" THEN
        IF In.Schaduw THEN
            R = Row + 1
            C = Col + 1
            GetMouseLoc MR, MC
            IF MR = R AND MC = C THEN C = C + 1
            K = SCREEN(R, C, 1)
            QPRINT STRING$(LEN(Text$) + 4, 223), Row + 1, Col + 1, K AND 240
            QPRINT CHR$(220), Row, Col + LEN(Text$) + 4, K AND 240
        END IF
        IF Ingedrukt AND Default THEN
            QPRINT " ", Row, Col, SCREEN(Row, Col - 1, 1)
            QPRINT SPACE$(LEN(Text$) + 4), Row + 1, Col + 1, SCREEN(Row + 1, Col, 1)
            QPRINT "  " + Text$ + "  ", Row, Col + 1, Kleur(17)
            LOCATE , , 0
        ELSEIF Default THEN
            QPRINT "  " + Text$ + "  ", Row, Col, Kleur(17)
            LOCATE Row, Col + 2, 1
        ELSE
            QPRINT "  " + Text$ + "  ", Row, Col, Kleur(16)
        END IF
    END IF
END SUB

SUB ClipBoard (Which, Buffer$)
    STATIC CopyText$
    STATIC Seltext$
    SELECT CASE Which
        CASE -1
            CopyText$ = Buffer$
        CASE -2
            Seltext$ = Buffer$
        CASE 1
            Buffer$ = CopyText$
        CASE 2
            Buffer$ = Seltext$
    END SELECT
END SUB

SUB CloseWin (Background())
    E = UBOUND(Background) - 3
    IF E > 0 THEN
        R1 = Background(E + 1) MOD 128
        C1 = Background(E + 1) \ 128
        R2 = Background(E + 2) MOD 128
        C2 = Background(E + 2) \ 128
        GetMouseLoc MRij, MKol
        IF MRij >= R1 AND MRij <= R2 AND MKol >= C1 AND MKol <= C2 AND In.Muis THEN MMCursorOff
        PutScreen Background(), R1, C1, R2, C2, 0, In.TekstSnel
        IF MRij >= R1 AND MRij <= R2 AND MKol >= C1 AND MKol <= C2 AND In.Muis THEN MMCursorOn
        CR = Background(E + 3) MOD 128
        CC = (Background(E + 3) AND 16383) \ 128
        LOCATE CR, CC, -((Background(E + 3) AND 16384) = 16384)
    END IF
    REDIM Background(0)
END SUB

SUB Compress (St$)
    DIM Ch1 AS STRING * 1, Ch2 AS STRING * 2
   
    T$ = SPACE$(33)
    FOR C = 33 TO 254
        P = INSTR("", CHR$(C))
        IF P THEN T$ = T$ + CHR$(P - 1) ELSE T$ = T$ + CHR$(C)
    NEXT C
    XLate St$, T$ + " "
    T$ = ""

'*** String crunch ***
    P = 1
    DO UNTIL P > LEN(St$) - 4
        Ch1 = MID$(St$, P, 1)
        L = 0
        DO
            L = L + 1
        LOOP UNTIL Ch1 <> MID$(St$, P + L, 1) OR L = 126
        IF L > 3 THEN
            St$ = LEFT$(St$, P - 1) + CHR$(30) + CHR$(L) + Ch1 + MID$(St$, P + L)
            P = P + 3
        ELSE
            P = P + 1
        END IF
        Ch2 = MID$(St$, P, 2)
        IF MID$(St$, P, 1) <> MID$(St$, P + 1, 1) THEN
            L = 0
            DO
                L = L + 2
            LOOP UNTIL Ch2 <> MID$(St$, P + L, 2) OR L = 252
            IF L > 4 THEN
                St$ = LEFT$(St$, P - 1) + CHR$(31) + CHR$(L / 2) + Ch2 + MID$(St$, P + L)
                P = P + 4
            END IF
        END IF
    LOOP
' *** Einde String Crunch ***

    FOR C = 128 TO 255
        P = INSTR(St$, CHR$(C))
        WHILE P
            St$ = LEFT$(St$, P - 1) + CHR$(127) + CHR$(C - 128) + MID$(St$, P + 1)
            P = INSTR(St$, CHR$(C))
        WEND
    NEXT C

' *** String Squish ***

   REDIM X$(128 TO 255)
   X$(128) = "van"
   X$(129) = "ij "
   X$(130) = " de"
   X$(131) = "het"
   X$(132) = "ing"
   X$(133) = "de "
   X$(134) = "en "
   X$(135) = " an"
   X$(136) = "ng "
   X$(137) = "nd "
   X$(138) = "een"
   X$(139) = " en"
   X$(140) = "te "
   X$(141) = " of"
   X$(142) = " wa"
   X$(143) = "of "
   X$(144) = "sc"
   X$(145) = "e "
   X$(146) = " t"
   X$(147) = "th"
   X$(148) = " a"
   X$(149) = "s "
   X$(150) = "he"
   X$(151) = "in"
   X$(152) = "t "
   X$(153) = "er"
   X$(154) = "d "
   X$(155) = "re"
   X$(156) = " s"
   X$(157) = " o"
   X$(158) = "or"
   X$(159) = "an"
   X$(160) = "n "
   X$(161) = " i"
   X$(162) = ", "
   X$(163) = "r "
   X$(164) = "ou"
   X$(165) = "te"
   X$(166) = "on"
   X$(167) = "ro"
   X$(168) = " w"
   X$(169) = "y "
   X$(170) = "to"
   X$(171) = "o "
   X$(172) = "le"
   X$(173) = "is"
   X$(174) = "nd"
   X$(175) = "at"
   X$(176) = "es"
   X$(177) = " c"
   X$(178) = "th"
   X$(179) = "ed"
   X$(180) = "ar"
   X$(181) = "en"
   X$(182) = "ti"
   X$(183) = "se"
   X$(184) = " f"
   X$(185) = "ng"
   X$(186) = "it"
   X$(187) = "f "
   X$(188) = "st"
   X$(189) = " b"
   X$(190) = "me"
   X$(191) = ". "
   X$(192) = " m"
   X$(193) = "ve"
   X$(194) = "of"
   X$(195) = "al"
   X$(196) = "ha"
   X$(197) = "ne"
   X$(198) = "nt"
   X$(199) = " r"
   X$(200) = "as"
   X$(201) = " d"
   X$(202) = "ra"
   X$(203) = "ri"
   X$(204) = "a "
   X$(205) = "de"
   X$(206) = "ll"
   X$(207) = " p"
   X$(208) = "co"
   X$(209) = "et"
   X$(210) = "l "
   X$(211) = "hi"
   X$(212) = "g "
   X$(213) = "il"
   X$(214) = "ut"
   X$(215) = "la"
   X$(216) = "ea"
   X$(217) = "be"
   X$(218) = "us"
   X$(219) = "ma"
   X$(220) = "pe"
   X$(221) = "am"
   X$(222) = " e"
   X$(223) = "wi"
   X$(224) = " l"
   X$(225) = "lo"
   X$(226) = " n"
   X$(227) = " h"
   X$(228) = "tr"
   X$(229) = "om"
   X$(230) = "ow"
   X$(231) = "h "
   X$(232) = "el"
   X$(233) = "ch"
   X$(234) = "pr"
   X$(235) = ": "
   X$(236) = "ec"
   X$(237) = "uu"
   X$(238) = "si"
   X$(239) = "io"
   X$(240) = "ur"
   X$(241) = "oe"
   X$(242) = " y"
   X$(243) = "ac"
   X$(244) = "li"
   X$(245) = "ca"
   X$(246) = " :"
   X$(247) = "fo"
   X$(248) = "ee"
   X$(249) = "fi"
   X$(250) = "di"
   X$(251) = "De"
   X$(252) = "rs"
   X$(253) = "ic"
   X$(254) = " u"
   X$(255) = "mo"
    DIM Ch AS STRING * 1
    FOR C% = 128 TO 254
        P = INSTR(St$, X$(C%))
        Ch = CHR$(C%)
        L = LEN(X$(C%))
        WHILE P
            St$ = LEFT$(St$, P - 1) + Ch + MID$(St$, P + L)
            P = INSTR(St$, X$(C%))
        WEND
    NEXT C%
    ERASE X$
' *** Einde String Squish ***
END SUB

FUNCTION EditString$ (InString$, Legal$, Length, Rest$, Visible, HotKey, Shift, Ctrl, Alt, Gewijzigd, Attr, CurPos, SelP)
    GetKbd Overwrite, Q, Q, Q
    CursorInfo X, X, X, MaxLine
    Work$ = InString$
    Rest$ = ""
    Row = CSRLIN: Column = POS(0)
    BP = 0
    Gewijzigd = 0
    P = CurPos
    IF P > LEN(Work$) THEN P = LEN(Work$)
    IF SelP > LEN(Work$) THEN SelP = LEN(Work$)
    IF P > BP + Visible THEN BP = P - Visible
  ' HotKey:
  '   Waarde   Actie
  '    1      Escape
  '    2      Ctrl+
  '    3      Shift+tab
  '    4      Tab
  '    5      PgUp
  '    6      PgDown
  '    7      Pijl-op
  '    8      Pijl-neer
  '    9      Muisknoplinks ingedrukt

  '   11      Naar links schuiven
  '   12      Naar rechts schuiven
  '   16-25   F1 t/m F10
  '   26-35   Shift+F1 t/m Shift+F10
  '   36-45   Ctrl+F1 t/m Ctrl+F10
  '   46-55   Alt+F1 t/m Alt+F10
    LP = -1
    QPRINT SPACE$(Visible), Row, Column, Attr
    GOSUB PrintTekst
    DO
        IF LEN(Work$) > Length THEN
            Work$ = LEFT$(Work$, Length)
            IF HotKey = -2 THEN
                Rest$ = RIGHT$(Work$, LEN(Work$) - Length)
                HotKey = 12
                Shift = ShiftFlag
                Ctrl = CtrlFlag
                Alt = AltFlag
                EXIT DO
            END IF
        END IF
        IF LP <> P OR LWork$ <> Work$ THEN GOSUB PrintTekst
        ShiftFlag = Shift
        CtrlFlag = Ctrl
        AltFlag = Alt
        Toets = UserInput(MRij, MKol, ShiftFlag, CtrlFlag, AltFlag, 0)
        GetKbd Ins, L, L, L
        Overwrite = Ins
        SELECT CASE Toets
            CASE 22
                ClipBoard 1, Buffer$
                IF SelP >= 0 THEN GOSUB DeleteText
                Work$ = LEFT$(Work$, P) + Buffer$ + MID$(Work$, P + 1)
                IF LEN(Buffer$) THEN Gewijzigd = -1
                IF LEN(Work$) > Length THEN
                    Work$ = LEFT$(Work$, Length)
                    IF HotKey = -2 THEN
                        Rest$ = RIGHT$(Work$, LEN(Work$) - Length)
                        HotKey = 12
                        Shift = ShiftFlag
                        Ctrl = CtrlFlag
                        Alt = AltFlag
                        EXIT DO
                    END IF
                END IF
                SelP = -1
            CASE 259
                Shift = ShiftFlag
                Ctrl = CtrlFlag
                Alt = AltFlag
                HotKey = 46
                EXIT DO
            CASE -68 TO -59   'F1 t/m F10
                IF HotKey THEN
                    HotKey = -Toets - 43
                    Shift = ShiftFlag
                    Ctrl = CtrlFlag
                    Alt = AltFlag
                    EXIT DO
                END IF
            CASE -93 TO -84   'Shift+F1 t/m Shift+F10
                IF HotKey THEN
                    HotKey = -Toets - 58
                    Shift = ShiftFlag
                    Ctrl = CtrlFlag
                    Alt = AltFlag
                    EXIT DO
                END IF
            CASE -103 TO -94   'Ctrl+F1 t/m Ctrl+F10
                IF HotKey THEN
                    HotKey = -Toets - 58
                    Shift = ShiftFlag
                    Ctrl = CtrlFlag
                    Alt = AltFlag
                    EXIT DO
                END IF
            CASE -113 TO -104   'Alt+F1 t/m Alt+F10
                IF HotKey THEN
                    HotKey = -Toets - 58
                    Shift = ShiftFlag
                    Ctrl = CtrlFlag
                    Alt = AltFlag
                    EXIT DO
                END IF
            CASE 10
                IF HotKey THEN
                    HotKey = 2
                    Shift = ShiftFlag
                    Ctrl = CtrlFlag
                    Alt = AltFlag
                    EXIT DO
                END IF
            CASE -115
                IF ShiftFlag THEN
                    IF SelP < 0 THEN SelP = P
                ELSE
                    SelP = -1
                    LP = -1
                END IF
                DO WHILE P > 0
                    P = P - 1
                    IF P < BP THEN BP = BP - 1
                    IF NOT P = 0 THEN
                        IF MID$(Work$, P, 1) = " " THEN EXIT DO
                    END IF
                LOOP
            CASE -116
                IF ShiftFlag THEN
                    IF SelP < 0 THEN SelP = P
                ELSE
                    SelP = -1
                    LP = -1
                END IF
                DO WHILE P < LEN(Work$)
                    P = P + 1
                    IF P > BP + Visible THEN BP = BP + 1
                    IF NOT P = 0 THEN
                        IF MID$(Work$, P, 1) = " " THEN EXIT DO
                    END IF
                LOOP
            CASE 26
                Work$ = InString$
                P = 0
                SelP = LEN(Work$)
                BP = 0
                Gewijzigd = 0
            CASE 3
                GOSUB CopyText
            CASE 25
                P = 0
                BP = 0
                SelP = LEN(Work$)
                GOSUB CopyText
                GOSUB DeleteText
            CASE 20
                SelP = LEN(Work$)
                GOSUB CopyText
                GOSUB DeleteText
            CASE -75, 19
                IF ShiftFlag THEN
                    IF SelP < 0 THEN SelP = P
                ELSE
                    SelP = -1
                    LP = -1
                END IF
                IF P > 0 THEN
                    P = P - 1
                    IF P < BP THEN BP = BP - 1
                ELSEIF HotKey = -2 THEN
                    HotKey = 11
                    IF ShiftFlag THEN Shift = -1 ELSE LP = -1
                    Ctrl = CtrlFlag
                    Alt = AltFlag
                    EXIT DO
                END IF
            CASE -77, 4
                IF ShiftFlag THEN
                    IF SelP < 0 THEN SelP = P
                ELSE
                    SelP = -1
                    LP = -1
                END IF
                IF P < LEN(Work$) THEN
                    P = P + 1
                    IF P > BP + Visible THEN BP = BP + 1
                ELSEIF HotKey = -2 THEN
                    HotKey = 12
                    IF ShiftFlag THEN Shift = -1 ELSE Shift = 0: LP = -1
                    Ctrl = CtrlFlag
                    Alt = AltFlag
                    EXIT DO
                END IF
            CASE 8
                IF P > 0 THEN
                    Work$ = LEFT$(Work$, P - 1) + MID$(Work$, P + 1)
                    Gewijzigd = -1
                    P = P - 1
                    IF P < BP THEN BP = BP - 1
                ELSEIF In.Pieptoon THEN
                    PLAY "O3L63AE"
                END IF
                SelP = -1
                LP = -1
            CASE -83, 127
                IF SelP >= 0 THEN
                    LP = -1
                    GOSUB DeleteText
                ELSEIF LEN(Work$) > P THEN
                    Work$ = LEFT$(Work$, P) + MID$(Work$, P + 2)
                    Gewijzigd = -1
                ELSEIF In.Pieptoon THEN
                    PLAY "O3L63AE"
                    LP = -1
                END IF
            CASE -71, 1
                IF ShiftFlag THEN
                    IF SelP < 0 THEN SelP = P
                ELSE
                    SelP = -1
                    LP = -1
                END IF
                P = 0
                BP = 0
            CASE -79, 6
                IF ShiftFlag THEN
                    IF SelP < 0 THEN SelP = P
                ELSE
                    SelP = -1
                    LP = -1
                END IF
                P = LEN(Work$)
                BP = P - Visible
                LP = -1
                IF BP < 0 THEN BP = 0
            CASE -73
                IF HotKey THEN
                    HotKey = 5
                    Shift = ShiftFlag
                    Ctrl = CtrlFlag
                    Alt = AltFlag
                    EXIT DO
                END IF
            CASE -81
                IF HotKey THEN
                    HotKey = 6
                    Shift = ShiftFlag
                    Ctrl = CtrlFlag
                    Alt = AltFlag
                    EXIT DO
                END IF
            CASE 13
                HotKey = 0
                Shift = ShiftFlag
                Ctrl = CtrlFlag
                Alt = AltFlag
                EXIT DO
            CASE 27
                HotKey = 1
                Shift = ShiftFlag
                Ctrl = CtrlFlag
                Alt = AltFlag
                Work$ = InString$
                Gewijzigd = 0
                EXIT DO
            CASE -15
                IF HotKey THEN
                    HotKey = 3
                    Shift = ShiftFlag
                    Ctrl = CtrlFlag
                    Alt = AltFlag
                    EXIT DO
                ELSEIF In.Pieptoon THEN
                    PLAY "O3L63AE"
                END IF
            CASE 9
                IF HotKey THEN
                    HotKey = 4
                    Shift = ShiftFlag
                    Ctrl = CtrlFlag
                    Alt = AltFlag
                    EXIT DO
                ELSEIF In.Pieptoon THEN
                    PLAY "O3L63AE"
                END IF
            CASE -72
                IF HotKey THEN
                    HotKey = 7
                    Shift = ShiftFlag
                    Ctrl = CtrlFlag
                    Alt = AltFlag
                    EXIT DO
                ELSEIF In.Pieptoon THEN
                    PLAY "O3L63AE"
                END IF
            CASE -80
                IF HotKey THEN
                    HotKey = 8
                    Shift = ShiftFlag
                    Ctrl = CtrlFlag
                    Alt = AltFlag
                    EXIT DO
                ELSEIF In.Pieptoon THEN
                    PLAY "O3L63AE"
                END IF
            CASE 256, 260
                IF MRij = Row AND MKol >= Column AND MKol <= Column + Visible THEN
                    IF MKol - Column <= LEN(Work$) THEN P = MKol - Column + BP
                    MousePressP = P
                    SelP = P
                    LP = -1
                    MousePressedInBox = -1
                ELSEIF HotKey THEN
                    HotKey = 9
                    Shift = ShiftFlag
                    Ctrl = CtrlFlag
                    Alt = AltFlag
                    EXIT DO
                END IF
            CASE 24
                GOSUB CopyText
                GOSUB DeleteText
            CASE 257
                IF MRij = Row AND MKol >= Column AND MKol <= Column + Visible AND MousePressedInBox THEN
                    IF MKol - Column <= LEN(Work$) THEN P = MKol - Column + BP
                ELSEIF MKol < Column AND MousePressedInBox THEN
                    IF BP > 0 THEN
                        BP = BP - 1
                        P = P - 1
                    END IF
                ELSEIF MKol > Column + Visible AND MousePressedInBox THEN
                    IF BP + Visible < LEN(Work$) THEN
                        BP = BP + 1
                        P = P + 1
                    END IF
                END IF
            CASE ELSE
                IF Toets >= 32 AND Toets <= 255 THEN
                    IF INSTR(Legal$, CHR$(Toets)) OR Legal$ = "" THEN
                        IF SelP > P THEN
                            Work$ = LEFT$(Work$, P) + MID$(Work$, SelP + 1)
                            Gewijzigd = -1
                        ELSEIF SelP < P AND SelP >= 0 THEN
                            Work$ = LEFT$(Work$, SelP) + MID$(Work$, P + 1)
                            Gewijzigd = -1
                            P = SelP
                            IF P < BP THEN BP = SelP
                        END IF
                        SelP = -1
                        LP = -1
                        IF Overwrite THEN
                            IF P < LEN(Work$) THEN
                                MID$(Work$, P + 1, 1) = CHR$(Toets)
                                P = P + 1
                                IF P > BP + Visible THEN BP = BP + 1
                                Gewijzigd = -1
                            ELSEIF LEN(Work$) < Length THEN
                                Work$ = Work$ + CHR$(Toets)
                                Gewijzigd = -1
                                P = P + 1
                                IF P > BP + Visible THEN BP = BP + 1
                            END IF
                        ELSE
                            IF P < LEN(Work$) THEN
                                Work$ = LEFT$(Work$, P) + CHR$(Toets) + MID$(Work$, P + 1)
                                Work$ = LEFT$(Work$, Length)
                                Gewijzigd = -1
                                P = P + 1
                                IF P > BP + Visible THEN BP = BP + 1
                            ELSEIF LEN(Work$) < Length THEN
                                Work$ = Work$ + CHR$(Toets)
                                Gewijzigd = -1
                                P = P + 1
                                IF P > BP + Visible THEN BP = BP + 1
                            ELSEIF HotKey <= -2 AND P = LEN(Work$) THEN
                                Rest$ = CHR$(Toets)
                                HotKey = 12
                                Shift = ShiftFlag
                                Ctrl = CtrlFlag
                                Alt = AltFlag
                                EXIT DO
                            END IF
                        END IF
                    ELSEIF In.Pieptoon THEN
                        PLAY "O3L63AE"
                    END IF
                END IF
        END SELECT
    LOOP
    IF NOT HotKey = 1 THEN CurPos = P
    IF SelP > P THEN
        ClipBoard -2, MID$(Work$, P + 1, SelP - P)
    ELSEIF SelP < P AND SelP >= 0 THEN
        ClipBoard -2, MID$(Work$, SelP + 1, P - SelP)
    ELSE
        ClipBoard -2, ""
    END IF
    EditString = Work$
    EXIT FUNCTION
CopyText:
    IF SelP > P THEN
        ClipBoard -1, MID$(Work$, P + 1, SelP - P)
        Gewijzigd = -1
    ELSEIF SelP < P AND SelP >= 0 THEN
        ClipBoard -1, MID$(Work$, SelP + 1, P - SelP)
        Gewijzigd = -1
    END IF
    RETURN
DeleteText:
    IF SelP > P THEN
        Work$ = LEFT$(Work$, P) + MID$(Work$, SelP + 1)
        Gewijzigd = -1
    ELSEIF SelP < P AND SelP >= 0 THEN
        Work$ = LEFT$(Work$, SelP) + MID$(Work$, P + 1)
        Gewijzigd = -1
        P = SelP
        IF P < BP THEN BP = SelP
    END IF
    LP = -1
    SelP = -1
    RETURN
PrintTekst:
    VW$ = Work$ + SPACE$(Length - LEN(Work$))
    QPRINT MID$(VW$, BP + 1, Visible), Row, Column, Attr
    LOCATE Row, Column + (P - BP), 1
    IF SelP >= 0 THEN
        L = 0
        IF SelP > P THEN
            IF SelP - BP > Visible THEN
                L = Visible - (P - BP)
            ELSE
                L = (SelP - BP) - (P - BP)
            END IF
            PP = P - BP
        ELSEIF SelP < P AND SelP >= 0 THEN
            IF SelP - BP < 0 THEN
                L = (P - BP)
                PP = 0
            ELSE
                L = (P - BP) - (SelP - BP)
                PP = SelP - BP
            END IF
        END IF
        IF L THEN QATTR Row, PP + Column, 1, L, (Attr AND 15) * 16 + Attr \ 16
    END IF
    LP = P
    LWork$ = Work$
    RETURN
END FUNCTION

SUB Expand (St$)
   REDIM X$(128 TO 255)

   X$(128) = "van"
   X$(129) = "ij "
   X$(130) = " de"
   X$(131) = "het"
   X$(132) = "ing"
   X$(133) = "de "
   X$(134) = "en "
   X$(135) = " an"
   X$(136) = "ng "
   X$(137) = "nd "
   X$(138) = "een"
   X$(139) = " en"
   X$(140) = "te "
   X$(141) = " of"
   X$(142) = " wa"
   X$(143) = "of "
   X$(144) = "sc"
   X$(145) = "e "
   X$(146) = " t"
   X$(147) = "th"
   X$(148) = " a"
   X$(149) = "s "
   X$(150) = "he"
   X$(151) = "in"
   X$(152) = "t "
   X$(153) = "er"
   X$(154) = "d "
   X$(155) = "re"
   X$(156) = " s"
   X$(157) = " o"
   X$(158) = "or"
   X$(159) = "an"
   X$(160) = "n "
   X$(161) = " i"
   X$(162) = ", "
   X$(163) = "r "
   X$(164) = "ou"
   X$(165) = "te"
   X$(166) = "on"
   X$(167) = "ro"
   X$(168) = " w"
   X$(169) = "y "
   X$(170) = "to"
   X$(171) = "o "
   X$(172) = "le"
   X$(173) = "is"
   X$(174) = "nd"
   X$(175) = "at"
   X$(176) = "es"
   X$(177) = " c"
   X$(178) = "th"
   X$(179) = "ed"
   X$(180) = "ar"
   X$(181) = "en"
   X$(182) = "ti"
   X$(183) = "se"
   X$(184) = " f"
   X$(185) = "ng"
   X$(186) = "it"
   X$(187) = "f "
   X$(188) = "st"
   X$(189) = " b"
   X$(190) = "me"
   X$(191) = ". "
   X$(192) = " m"
   X$(193) = "ve"
   X$(194) = "of"
   X$(195) = "al"
   X$(196) = "ha"
   X$(197) = "ne"
   X$(198) = "nt"
   X$(199) = " r"
   X$(200) = "as"
   X$(201) = " d"
   X$(202) = "ra"
   X$(203) = "ri"
   X$(204) = "a "
   X$(205) = "de"
   X$(206) = "ll"
   X$(207) = " p"
   X$(208) = "co"
   X$(209) = "et"
   X$(210) = "l "
   X$(211) = "hi"
   X$(212) = "g "
   X$(213) = "il"
   X$(214) = "ut"
   X$(215) = "la"
   X$(216) = "ea"
   X$(217) = "be"
   X$(218) = "us"
   X$(219) = "ma"
   X$(220) = "pe"
   X$(221) = "am"
   X$(222) = " e"
   X$(223) = "wi"
   X$(224) = " l"
   X$(225) = "lo"
   X$(226) = " n"
   X$(227) = " h"
   X$(228) = "tr"
   X$(229) = "om"
   X$(230) = "ow"
   X$(231) = "h "
   X$(232) = "el"
   X$(233) = "ch"
   X$(234) = "pr"
   X$(235) = ": "
   X$(236) = "ec"
   X$(237) = "uu"
   X$(238) = "si"
   X$(239) = "io"
   X$(240) = "ur"
   X$(241) = "oe"
   X$(242) = " y"
   X$(243) = "ac"
   X$(244) = "li"
   X$(245) = "ca"
   X$(246) = " :"
   X$(247) = "fo"
   X$(248) = "ee"
   X$(249) = "fi"
   X$(250) = "di"
   X$(251) = "De"
   X$(252) = "rs"
   X$(253) = "ic"
   X$(254) = " u"
   X$(255) = "mo"

FOR C% = 128 TO 254
    P = INSTR(St$, CHR$(C%))
    WHILE P
        St$ = LEFT$(St$, P - 1) + X$(C%) + MID$(St$, P + 1)
        P = INSTR(St$, CHR$(C%))
    WEND
NEXT C%
ERASE X$
'***
    FOR C = 128 TO 255
        P = INSTR(St$, CHR$(127) + CHR$(C - 128))
        WHILE P
            St$ = LEFT$(St$, P - 1) + CHR$(C) + MID$(St$, P + 2)
            P = INSTR(St$, CHR$(127) + CHR$(C - 128))
        WEND
    NEXT C
   
'***
    DIM Ch1 AS STRING * 1, Ch2 AS STRING * 2
    P = INSTR(St$, CHR$(30))
    WHILE P
        L = ASC(MID$(St$, P + 1, 2))
        Ch1 = MID$(St$, P + 2, 1)
        St$ = LEFT$(St$, P - 1) + STRING$(L, Ch1) + MID$(St$, P + 3)
        P = INSTR(St$, CHR$(30))
    WEND
    P = INSTR(St$, CHR$(31))
    WHILE P
        L = ASC(MID$(St$, P + 1))
        Ch2 = MID$(St$, P + 2, 2)
        Q$ = ""
        FOR a = 1 TO L
            Q$ = Q$ + Ch2
        NEXT a
        St$ = LEFT$(St$, P - 1) + Q$ + MID$(St$, P + 4)
        P = INSTR(St$, CHR$(31))
    WEND
'***

    T$ = ""
    FOR C = 30 TO 255
        T$ = T$ + CHR$(C)
    NEXT C
    XLate St$, T$
END SUB

SUB HelpWindow (TpcNum)
    STATIC YetLoaded, OpenWindows, NowWindow, TopicNum()
    IF NOT YetLoaded THEN DIM TopicNum(1 TO 32)
    IF TpcNum = 0 THEN EXIT SUB
    REDIM HR(0) AS STRING * 67, HKol1(0, 0), HKol2(0, 0), BTpcNum(0, 0)
    REDIM HAantal(0), BAantal(0), Background(0)
    Hght = In.Rijen - 4 - 3
    VRij = In.Rijen / 2 - (Hght + 3) / 2
    CONST VKol = 7 'Ik heb het niet aan het programma toegevoegd dat
    IF OpenWindows = 32 THEN 'je vensters kan bewegen (staat zo overdreven)
        NowWindow = 1 'dus VKol blijft constant (anders kost dat weer
    ELSE '4 bytes aan geheugen (pointer)
        NowWindow = NowWindow + 1
        IF NowWindow > 32 THEN NowWindow = 1
        OpenWindows = OpenWindows + 1
        DRecIns VARSEG(TopicNum(1)), VARPTR(TopicNum(1)), NowWindow, 2, 32
    END IF
    TopicNum(NowWindow) = TpcNum
    GOSUB LoadTopic
    Rij = 1
    Kol = 0
    BR = 1
    GOSUB Redraw
    FOR R = 1 TO Hght - 6
        QPRINT "", R + VRij + 3, VKol + 69, Kleur(16)
    NEXT R
    ButtonType = 6
    SelButton$ = SelectButton(VRij + Hght, VKol + 19, VRij, VKol, ButtonType + 2048, MRij, MKol, Toets)
    Default = 1
    DO
        IF LDefault <> Default THEN
            IF Default = 1 THEN LOCATE Rij - BR + VRij + 3, VKol + 2, 1
            LDefault = Default
        END IF
        SELECT CASE Default
            CASE 1
                IF LBR <> BR THEN
                    IF Aantal > Hght - 4 THEN
                        IF LBR = 0 THEN LBR = 1
                        R = (LBR - 1) / (Aantal - Hght + 4) * (Hght - 7) + VRij + 4
                        QATTR R, VKol + 69, 1, 1, Kleur(16)
                        R = (BR - 1) / (Aantal - Hght + 4) * (Hght - 7) + VRij + 4
                        QATTR R, VKol + 69, 1, 1, Kleur(17)
                    END IF
                    IF BR > 1 THEN
                        QPRINT "", VRij + 2, VKol + 3, Kleur(11)
                    ELSE
                        QPRINT "", VRij + 2, VKol + 3, Kleur(11)
                    END IF
                    IF BR + Hght - 4 < Aantal THEN
                        QPRINT "", VRij + Hght - 1, VKol + 67, Kleur(11)
                    ELSE
                        QPRINT "", VRij + Hght - 1, VKol + 67, Kleur(11)
                    END IF
                    LBR = BR
                END IF
                IF LKol <> Kol OR LRij <> Rij OR LBR <> BR THEN
                    IF NOT (LRij < BR OR LRij > BR + Hght - 5) THEN
                        FOR Y = 1 TO HAantal(LRij)
                            IF BTpcNum(LRij, Y) THEN
                                QATTR LRij - BR + VRij + 3, VKol + 1 + HKol1(LRij, Y), 1, HKol2(LRij, Y) - HKol1(LRij, Y) + 1, Kleur(13)
                            ELSE
                                QATTR LRij - BR + VRij + 3, VKol + 1 + HKol1(LRij, Y), 1, HKol2(LRij, Y) - HKol1(LRij, Y) + 1, Kleur(12)
                            END IF
                        NEXT Y
                    END IF
                    LOCATE Rij - BR + VRij + 3, VKol + 2
                    FOR Y = 1 TO HAantal(Rij)
                        IF Y = Kol THEN
                            QATTR Rij - BR + VRij + 3, VKol + 1 + HKol1(Rij, Y), 1, HKol2(Rij, Y) - HKol1(Rij, Y) + 1, Kleur(14)
                            LOCATE , VKol + 1 + HKol1(Rij, Y), 1
                        ELSEIF BTpcNum(Rij, Y) THEN
                            QATTR Rij - BR + VRij + 3, VKol + 1 + HKol1(Rij, Y), 1, HKol2(Rij, Y) - HKol1(Rij, Y) + 1, Kleur(13)
                        ELSE
                            QATTR Rij - BR + VRij + 3, VKol + 1 + HKol1(Rij, Y), 1, HKol2(Rij, Y) - HKol1(Rij, Y) + 1, Kleur(12)
                        END IF
                    NEXT Y
                    LRij = Rij
                    LKol = Kol
                END IF
                Toets = UserInput(MRij, MKol, 0, 0, 0, 0)
            CASE ELSE
                SelButton$ = SelectButton(VRij + Hght, VKol + 19, VRij, VKol, ButtonType, MRij, MKol, Toets)
        END SELECT
        SELECT CASE Toets
            CASE 9
                Default = Default + 1
                IF Default > 2 THEN Default = 1
            CASE -15
                Default = Default - 1
                IF Default < 1 THEN Default = 2
            CASE -77
                IF Default = 1 THEN
                    Kol = Kol + 1
                    IF Kol > BAantal(Rij) THEN
                        DO
                            Rij = Rij + 1
                            IF Rij > Aantal THEN
                                Rij = Rij - 1
                                IF Rij < BR THEN GOSUB Eenregelomhoog
                                EXIT DO
                            END IF
                            IF Rij > BR + Hght - 5 THEN GOSUB Eenregelomlaag
                        LOOP UNTIL BAantal(Rij)
                        IF BAantal(Rij) THEN Kol = 1 ELSE Kol = 0
                    END IF
                END IF
            CASE -80
                IF Default = 1 THEN IF BR + Hght - 4 < Aantal THEN GOSUB Eenregelomlaag
            CASE -75
                IF Default = 1 THEN
                    Kol = Kol - 1
                    IF Kol < 1 THEN
                        DO
                            Rij = Rij - 1
                            IF Rij < 1 THEN
                                Rij = Rij + 1
                                IF Rij < BR + VHght - 5 THEN GOSUB Eenregelomlaag
                                EXIT DO
                            END IF
                            IF Rij < BR THEN GOSUB Eenregelomhoog
                        LOOP UNTIL BAantal(Rij)
                        Kol = BAantal(Rij)
                    END IF
                END IF
            CASE -72
                IF Default = 1 THEN IF BR > 1 THEN GOSUB Eenregelomhoog
            CASE -73
                IF Default = 1 THEN
                    IF BR - Hght + 4 > 1 THEN
                        BR = BR - Hght + 4
                        Rij = Rij - Hght + 4
                    ELSE
                        BR = 1
                        Rij = 1
                    END IF
                    Kol = 0
                    IF BR <> LBR THEN GOSUB Redraw
                END IF
            CASE -81
                IF Default = 1 THEN
                    IF BR + Hght - 4 < Aantal - Hght + 4 THEN
                        BR = BR + Hght - 4
                        Rij = Rij + Hght - 4
                    ELSE
                        BR = Aantal - Hght + 5
                        IF BR < 1 THEN BR = 1
                        Rij = BR
                    END IF
                    Kol = 0
                    IF BR <> LBR THEN GOSUB Redraw
                END IF
            CASE 256
                Default = 2
                IF MRij > VRij + 2 AND MRij <= Hght - 3 + VRij AND MKol = VKol + 69 THEN Default = 1
                IF (MRij = VRij + 3 AND MKol = VKol + 69) OR (MRij = VRij + Hght - 1 AND MKol > 8 AND MKol < VKol + 69) THEN Default = 1
                IF (MRij = Hght - 2 + VRij AND MKol = VKol + 69) OR (MRij = VRij + 2 AND MKol > 8 AND MKol < VKol + 69) THEN Default = 1
                IF MRij > VRij + 2 AND MKol > VKol + 1 AND MRij < VRij + Hght - 1 AND MKol < VKol + 69 THEN
                    Rij = (MRij - (VRij + 1)) + BR - 2
                    Kol = 0
                    FOR Y = 1 TO HAantal(Rij)
                        IF MKol >= VKol + 1 + HKol1(Rij, Y) AND MKol <= VKol + 1 + HKol2(Rij, Y) AND BTpcNum(Rij, Y) > 0 THEN
                            Kol = Y
                            Default = 1
                            EXIT FOR
                        END IF
                    NEXT Y
                END IF
                Wachttijd! = 0
            CASE 257
                IF TIMER - Wachttijd! >= .05 AND Default = 1 THEN
                    IF Aantal > Hght - 4 THEN
                        IF MRij <= Hght - 3 + VRij AND MRij > (BR - 1) / (Aantal - Hght + 4) * (Hght - 7) + VRij + 4 AND MKol = VKol + 69 THEN
                            IF BR + Hght - 4 < Aantal THEN GOSUB Eenregelomlaag
                        END IF
                        IF MRij > VRij + 2 AND MRij < (BR - 1) / (Aantal - Hght + 4) * (Hght - 7) + VRij + 4 AND MKol = VKol + 69 THEN
                            IF BR > 1 THEN GOSUB Eenregelomhoog
                        END IF
                    END IF
                    IF (MRij = Hght - 2 + VRij AND MKol = VKol + 69) OR (MRij = VRij + Hght - 1 AND MKol > VKol + 1 AND MKol < VKol + 69) THEN
                        IF BR + Hght - 4 < Aantal THEN GOSUB Eenregelomlaag
                    END IF
                    IF (MRij = VRij + 3 AND MKol = VKol + 69) OR (MRij = VRij + 2 AND MKol > VKol + 1 AND MKol < VKol + 69) THEN
                        IF BR > 1 THEN
                            GOSUB Eenregelomhoog
                        ELSE
                            BR = 1
                            Rij = 1
                        END IF
                        Kol = 0
                    END IF
                    Wachttijd! = TIMER
                END IF
                IF Default = 1 THEN
                    IF (MRij > VRij + 2 AND MKol > VKol + 1 AND MRij < VRij + Hght - 1) AND MKol < VKol + 69 THEN
                        Rij = (MRij - (VRij + 1)) + BR - 2
                        Kol = 0
                        FOR Y = 1 TO HAantal(Rij)
                            IF MKol >= VKol + 1 + HKol1(Rij, Y) AND MKol <= VKol + 1 + HKol2(Rij, Y) AND BTpcNum(Rij, Y) > 0 THEN
                                Kol = Y
                                EXIT FOR
                            END IF
                        NEXT Y
                    END IF
                END IF
            CASE 258
                IF Default = 1 THEN
                    IF Kol THEN
                        IF OpenWindows < 32 THEN
                            NowWindow = NowWindow + 1
                            IF NowWindow > 32 THEN NowWindow = 1
                            OpenWindows = OpenWindows + 1
                            DRecIns VARSEG(TopicNum(1)), VARPTR(TopicNum(1)), NowWindow, 2, 32
                        ELSE
                            NowWindow = 1
                        END IF
                        TopicNum(NowWindow) = BTpcNum(Rij, Kol)
                        GOSUB LoadTopic
                    END IF
                END IF
            CASE 0
                IF Default = 2 THEN
                    SELECT CASE SelButton$
                        CASE "OK"
                            EXIT DO
                        CASE "VORIGE"
                            NowWindow = NowWindow - 1
                            IF NowWindow = 0 THEN NowWindow = OpenWindows
                            GOSUB LoadTopic
                        CASE ELSE
                    END SELECT
                END IF
            CASE 27
                EXIT DO
            CASE 32, 13
                IF Default = 1 AND Kol > 0 THEN
                    IF OpenWindows < 32 THEN
                        NowWindow = NowWindow + 1
                        IF NowWindow > 32 THEN NowWindow = 1
                        OpenWindows = OpenWindows + 1
                        DRecIns VARSEG(TopicNum(1)), VARPTR(TopicNum(1)), NowWindow, 2, 32
                    ELSE
                        NowWindow = 1
                    END IF
                    TopicNum(NowWindow) = BTpcNum(Rij, Kol)
                    GOSUB LoadTopic
                END IF
            CASE ELSE
        END SELECT
    LOOP
    CloseWin Background()
    QPRINT SPACE$(80), In.Rijen, 1, Kleur(19)
    EXIT SUB

LoadTopic:
    REDIM HR(1 TO 82) AS STRING * 67, HKol1(1 TO 82, 1 TO 10)
    REDIM HKol2(1 TO 82, 1 TO 10), BTpcNum(1 TO 82, 1 TO 10), HAantal(82), BAantal(82)
    Title$ = ""
    IF TopicNum(NowWindow) < 1 THEN
        IF NowWindow > 32 THEN NowWindow = 1
        DRecDel VARSEG(TopicNum(1)), VARPTR(TopicNum(1)), NowWindow, 2, 32
        OpenWindows = OpenWindows - 1
        IF OpenWindows = 0 THEN
            IF In.Pieptoon THEN PLAY "O3L63AE"
            CloseWin Background()
            QPRINT SPACE$(80), In.Rijen, 1, Kleur(19)
            EXIT SUB
        END IF
        RETURN
    END IF
    IF NOT Exist2(HelpFile$) THEN
        IF In.Pieptoon THEN PLAY "O3L63AE"
        T$ = "Helpbestand niet gevonden!|"
        T$ = T$ + "Het helpbestand moet in dezelfde directory|"
        T$ = T$ + "staan als het programma of in een directory|"
        T$ = T$ + "staan die in het zoekpad staat."
        Antwrd$ = MSGBox(T$, 0, "Fout", 0)
        EXIT SUB
    END IF
    QPRINT SPACE$(80), In.Rijen, 1, Kleur(19)
    QPRINT "Even wachten alsjeblieft" + SPACE$(61), In.Rijen, 1, Kleur(19)
    IF NOT YetLoaded THEN OPEN HelpFile$ FOR BINARY AS #100: YetLoaded = -1
  ' Gegevens uit het helpbestand halen
    GET #100, (TopicNum(NowWindow) - 1) * 2 + 1, B1
    GET #100, TopicNum(NowWindow) * 2 + 1, B2
    T$ = SPACE$(B2 - B1)
    GET #100, B1, T$
    Expand T$
    TL = LEN(T$)
    Aantal = 0
    Start = 0
    SLen = 0
    DO UNTIL Start = TL + 1
        Extract T$, "_", Aantal + 1, Start, SLen
        IF Aantal = 0 THEN
            Title$ = MID$(T$, Start, SLen)
        ELSE
            L$ = MID$(T$, Start, SLen)
            WHILE INSTR(L$, CHR$(34))
                P1 = INSTR(L$, CHR$(34))
                P2 = INSTR(P1 + 1, L$, CHR$(34))
                HAantal(Aantal) = HAantal(Aantal) + 1
                W$ = MID$(L$, P1 + 1, P2 - P1 - 1)
                IF ASC(MID$(W$, P2 - P1 - 1, 1)) > 127 THEN
                    BAantal(Aantal) = BAantal(Aantal) + 1
                    BTpcNum(Aantal, HAantal(Aantal)) = ASC(MID$(W$, P2 - P1 - 1, 1)) - 190
                    IF BTpcNum(Aantal, HAantal(Aantal)) < 1 THEN BAantal(Aantal) = BAantal(Aantal) - 1
                    P3 = P2 - 1
                ELSE
                    P3 = P2
                END IF
                HKol1(Aantal, HAantal(Aantal)) = P1
                HKol2(Aantal, HAantal(Aantal)) = P3 - 2
                L$ = LEFT$(L$, P3 - 1) + RIGHT$(L$, LEN(L$) - P2)
                L$ = LEFT$(L$, P1 - 1) + RIGHT$(L$, LEN(L$) - P1)
            WEND
            HR(Aantal) = L$ + SPACE$(67)
        END IF
        Aantal = Aantal + 1
    LOOP
    T$ = ""
    IF UBOUND(Background) = 0 THEN   'Venster is nog niet op scherm
        OpenWin VRij, VKol, Hght + 3, 71, Kleur(11), 2, In.Schaduw, Kleur(15), "Help", Background()
        Panel VRij + 2, VKol + 1, Hght - 2, 69, 1, Kleur(11)
        QPRINT CHR$(24), VRij + 3, VKol + 69, Kleur(16)
        QPRINT CHR$(25), VRij + Hght - 2, VKol + 69, Kleur(16)
        FOR R = 1 TO Hght - 6
            QPRINT "", R + VRij + 3, VKol + 69, Kleur(16)
        NEXT R
    END IF
    IF Aantal > Hght - 4 THEN
        QATTR VRij + 3, VKol + 69, Hght - 4, 1, Kleur(16)
    ELSE
        QATTR VRij + 3, VKol + 69, Hght - 4, 1, (Kleur(18) MOD 16) + (Kleur(16) AND 240)
    END IF
    QPRINT SPACE$(69), VRij + 1, VKol + 1, Kleur(11)
    QPRINT Title$, VRij + 1, (VKol + 70 - LEN(Title$)) \ 2, Kleur(11)
    Panel VRij + 3, VKol + 2, Hght - 4, 67, 0, Kleur(11)
    QPRINT " Escape=Sluiten          ", In.Rijen, 1, Kleur(19)
    Rij = 1
    Kol = 0
    BR = 1
    LRij = 0
    LKol = 0
    LBR = 0
    LDefault = -1
    GOSUB Redraw
    RETURN

Redraw:
    ER = BR + Hght - 5
    FOR X = BR TO ER
        QPRINT HR(X), X - BR + VRij + 3, VKol + 2, Kleur(11)
        FOR Y = 1 TO HAantal(X)
            IF X = Rij AND Y = Kol THEN
                QATTR X - BR + VRij + 3, VKol + 1 + HKol1(X, Y), 1, HKol2(X, Y) - HKol1(X, Y) + 1, Kleur(14)
            ELSEIF BTpcNum(X, Y) THEN
                QATTR X - BR + VRij + 3, VKol + 1 + HKol1(X, Y), 1, HKol2(X, Y) - HKol1(X, Y) + 1, Kleur(13)
            ELSE
                QATTR X - BR + VRij + 3, VKol + 1 + HKol1(X, Y), 1, HKol2(X, Y) - HKol1(X, Y) + 1, Kleur(12)
            END IF
        NEXT Y
    NEXT X
    RETURN

Eenregelomhoog:
    BR = BR - 1
    IF Rij >= BR + (Hght - 4) THEN Rij = Rij - 1
    IF BAantal(Rij) < Kol THEN Kol = 0
    ScrollUp VRij + 3, VKol + 2, Hght - 4, 67, Kleur(11), 1
    QPRINT HR(BR), VRij + 3, VKol + 2, Kleur(11)
    FOR Y = 1 TO HAantal(BR)
        IF BR = Rij AND Y = Kol THEN
            QATTR VRij + 3, VKol + 1 + HKol1(BR, Y), 1, HKol2(BR, Y) - HKol1(BR, Y) + 1, Kleur(14)
        ELSEIF BTpcNum(BR, Y) THEN
            QATTR VRij + 3, VKol + 1 + HKol1(BR, Y), 1, HKol2(BR, Y) - HKol1(BR, Y) + 1, Kleur(13)
        ELSE
            QATTR VRij + 3, VKol + 1 + HKol1(BR, Y), 1, HKol2(BR, Y) - HKol1(BR, Y) + 1, Kleur(12)
        END IF
    NEXT Y
    RETURN

Eenregelomlaag:
    BR = BR + 1
    IF Rij < BR THEN Rij = Rij + 1
    IF BAantal(Rij) < Kol THEN Kol = 0
    ScrollDown VRij + 3, VKol + 2, Hght - 4, 67, Kleur(11), 1
    QPRINT HR(BR + Hght - 5), VRij + Hght - 2, VKol + 2, Kleur(11)
    FOR Y = 1 TO HAantal(BR + Hght - 5)
        IF BR + Hght - 5 = Rij AND Y = Kol THEN
            QATTR Hght - 2 + VRij, VKol + 1 + HKol1(BR + Hght - 5, Y), 1, HKol2(BR + Hght - 5, Y) - HKol1(BR + Hght - 5, Y) + 1, Kleur(14)
        ELSEIF BTpcNum(BR + Hght - 5, Y) THEN
            QATTR Hght - 2 + VRij, VKol + 1 + HKol1(BR + Hght - 5, Y), 1, HKol2(BR + Hght - 5, Y) - HKol1(BR + Hght - 5, Y) + 1, Kleur(13)
        ELSE
            QATTR Hght - 2 + VRij, VKol + 1 + HKol1(BR + Hght - 5, Y), 1, HKol2(BR + Hght - 5, Y) - HKol1(BR + Hght - 5, Y) + 1, Kleur(12)
        END IF
    NEXT Y
    RETURN
END SUB

FUNCTION MSGBox$ (Msg$, ButtonType, Title$, HelpTpcNum)
    DIM MsgRegel$(48)
    REDIM Background(0)
    MsgLen = LEN(Msg$)
    DO
        MsgRegels = MsgRegels + 1
        Extract Msg$, "|", MsgRegels, Start, SLen
        MsgRegel$(MsgRegels) = MID$(Msg$, Start, SLen)
        IF Breedte < SLen + 1 THEN Breedte = SLen + 1
    LOOP WHILE Start + SLen < MsgLen
    SelButton$ = SelectButton(0, 0, 0, 0, ButtonType + 1024, 0, 0, ButtonBreedte)
    IF Breedte < ButtonBreedte THEN Breedte = ButtonBreedte
    IF Breedte < LEN(Title$) + 4 THEN Breedte = LEN(Title$) + 4
    IF Breedte > 75 THEN Breedte = 75
    VKol = (73 - Breedte) \ 2
    VRij = (In.Rijen - MsgRegels - 6) \ 2
    OpenWin VRij, VKol, MsgRegels + 6, Breedte + 3, Kleur(8), 2, In.Schaduw, Kleur(15), Title$, Background()
    QPRINT SPACE$(80), In.Rijen, 1, Kleur(19)
    QPRINT "F1=Help  Enter=Uitvoeren  Esc=Annuleren  Tab=Volgende veld", In.Rijen, 1, Kleur(19)
  ' plaats de tekst
    FOR X = 1 TO MsgRegels
        QPRINT LEFT$(MsgRegel$(X) + SPACE$(Breedte - 1), Breedte - 1), VRij + X + 1, VKol + 2, Kleur(8)
    NEXT X
    Default = 2
    DO
        SelButton$ = SelectButton(VRij + MsgRegels + 3, VKol + (Breedte - ButtonBreedte + 9) \ 2, VRij, VKol, ButtonType, MRij, MKol, Toets)
        SELECT CASE Toets
            CASE 27
                MSGBox$ = "ESCAPE"
                EXIT DO
            CASE 9
            CASE -15
            CASE 32, 13
                IF EBIngedrukt THEN
                    MSGBox$ = "ESCAPE"
                ELSE
                    MSGBox$ = SelButton$
                END IF
                EXIT DO
            CASE 258
                IF LEN(SelButton$) THEN
                    MSGBox$ = SelButton$
                    EXIT DO
                END IF
            CASE -59
                IF HelpTpcNum THEN
                    HelpWindow HelpTpcNum
                    QPRINT "F1=Help  Enter=Uitvoeren  Esc=Annuleren  Tab=Volgende veld", In.Rijen, 1, Kleur(19)
                END IF
            CASE ELSE
                IF LEN(SelButton$) THEN
                    MSGBox$ = SelButton$
                    EXIT DO
                END IF
        END SELECT
    LOOP
    CloseWin Background()
    QPRINT SPACE$(80), In.Rijen, 1, Kleur(19)
END FUNCTION

SUB OpenWin (Row, Col, Hght, Wdth, Attr, Frm, Shadow, Label, Label$, Background())
    CursorInfo Visible, 0, 0, 0
    E = (Hght + 1) * (Wdth + 2)
    R1 = Row
    C1 = Col
    R2 = Row + Hght
    C2 = Col + Wdth + 1
    REDIM Background(1 TO E + 3)
    GetMouseLoc MRij, MKol
    IF MRij >= R1 AND MRij <= R2 AND MKol >= C1 AND MKol <= C2 AND In.Muis THEN MMCursorOff
    GetScreen Background(), R1, C1, R2, C2, 0, In.TekstSnel
    IF MRij >= R1 AND MRij <= R2 AND MKol >= C1 AND MKol <= C2 AND In.Muis THEN MMCursorOn
    Background(E + 1) = R1 + C1 * 128
    Background(E + 2) = R2 + C2 * 128
    Background(E + 3) = CSRLIN + POS(0) * 128 + ((Visible = 1) AND 16384)
    Page = 0
    ScrMode = 1
    F = Frm
    IF F >= 12 THEN F = 12
    TKADER$ = "   Ŀͻ͸ͻķĿķ͸" + STRING$(3, Frm)
    MKADER$ = "                  " + CHR$(Frm) + " " + CHR$(Frm)
    BKADER$ = "   ͼĽͼ;Ľ;" + STRING$(3, Frm)
    TOP$ = MID$(TKADER$, F * 3 + 1, 1) + STRING$(Wdth - 2, MID$(TKADER$, F * 3 + 2)) + MID$(TKADER$, F * 3 + 3, 1)
    MIDDLE$ = MID$(MKADER$, F * 3 + 1, 1) + STRING$(Wdth - 2, MID$(MKADER$, F * 3 + 2)) + MID$(MKADER$, F * 3 + 3, 1)
    BOTTOM$ = MID$(BKADER$, F * 3 + 1, 1) + STRING$(Wdth - 2, MID$(BKADER$, F * 3 + 2)) + MID$(BKADER$, F * 3 + 3, 1)
    IF Label > 0 THEN
        TOP$ = SPACE$(Wdth)
        IF LEN(Label$) < Wdth THEN MID$(TOP$, (Wdth - LEN(Label$)) / 2) = Label$
        QPRINT TOP$, Row, Col, Label
    ELSE
        QPRINT TOP$, Row, Col, Attr
    END IF
    FOR R = Row + 1 TO Row + Hght - 2
        QPRINT MIDDLE$, R, Col, Attr
    NEXT R
    QPRINT BOTTOM$, Row + Hght - 1, Col, Attr
    IF Shadow THEN
        QATTR Row + 1, Col + Wdth, Hght, 2, 0
        QATTR Row + Hght, Col + 2, 1, Wdth - 2, 0
    END IF
END SUB

SUB Panel (Row, Col, Hght, Wdth, Brdr, Attr)
    IF Brdr > 32 THEN Lijnen = Brdr: B = 12 ELSE B = Brdr
    K1$ = "   Ŀͻ͸ͻķĿķ͸" + STRING$(3, Lijnen)
    K2$ = "                  " + CHR$(Lijnen) + " " + CHR$(Lijnen)
    K3$ = "   ͼĽͼ;Ľ;" + STRING$(3, Lijnen)
    QPRINT MID$(K1$, B * 3 + 1, 1) + STRING$(Wdth - 2, MID$(K1$, B * 3 + 2, 1)) + MID$(K1$, B * 3 + 3, 1), Row, Col, Attr
    FOR R = Row + 1 TO Row + Hght - 2
        QPRINT MID$(K2$, B * 3 + 1, 1) + STRING$(Wdth - 2, MID$(K2$, B * 3 + 2, 1)) + MID$(K2$, B * 3 + 3, 1), R, Col, Attr
    NEXT R
    QPRINT MID$(K3$, B * 3 + 1, 1) + STRING$(Wdth - 2, MID$(K3$, B * 3 + 2, 1)) + MID$(K3$, B * 3 + 3, 1), Row + Hght - 1, Col, Attr
END SUB

DEFSNG A-Z
SUB RInstr (MainSt$, SubSt$, Posn%)
   Main$ = MainSt$
   Sub$ = SubSt$
   Reverse Main$
   Reverse Sub$
   tmp% = INSTR(Main$, Sub$)
   IF tmp% THEN
      Posn% = LEN(Main$) - LEN(Sub$) - tmp% + 2
   ELSE
      Posn% = 0
   END IF
END SUB

DEFINT A-Z
FUNCTION SelectButton$ (ButtonRow, ButtonCol, SysKnopRij, SysKnopKol, ButtonType, MRij, MKol, Toets)
    REDIM ButtonText$(1 TO 3)
    SELECT CASE ButtonType MOD 256
        CASE 0
            ButtonText$(1) = "OK"
            Buttons = 1
        CASE 1
            ButtonText$(1) = "OK"
            ButtonText$(2) = "Annuleren"
            ButtonText$(3) = "Help"
            Buttons = 3
        CASE 2
            ButtonText$(1) = "Afbreken"
            ButtonText$(2) = "Herhalen"
            ButtonText$(3) = "Negeren"
            Buttons = 3
        CASE 3
            ButtonText$(1) = "Ja"
            ButtonText$(2) = "Nee"
            ButtonText$(3) = "Annuleren"
            Buttons = 3
        CASE 4
            ButtonText$(1) = "Ja"
            ButtonText$(2) = "Nee"
            Buttons = 2
        CASE 5
            ButtonText$(1) = "Herhalen"
            ButtonText$(2) = "Annuleren"
            Buttons = 2
        CASE 6
            ButtonText$(1) = "OK"
            ButtonText$(2) = "Vorige"
            Buttons = 2
        CASE ELSE
            ButtonText$(1) = "OK"
            Buttons = 1
    END SELECT
    IF ButtonType AND 512 THEN
        IF Buttons >= 3 THEN Default = 3
    ELSEIF ButtonType AND 256 THEN
        IF Buttons >= 2 THEN Default = 2
    ELSE
        Default = 1
    END IF
    DIM BCol(3)
    Y = ButtonCol
    FOR X = 1 TO Buttons
        BCol(X) = Y
        Y = Y + LEN(ButtonText$(X)) + 12
    NEXT X
    IF ButtonType AND 1024 THEN
        Toets = Y - ButtonCol + 1 'Geef de breedte van alle buttons
        EXIT FUNCTION
    END IF
    QPRINT "[-]", SysKnopRij, SysKnopKol, Kleur(16)
    FirstTime = -1
    Toets = 0
    DO
        IF Default <> LDefault OR LIngedrukt <> Ingedrukt THEN
            FOR X = 1 TO Buttons
                Button ButtonRow, BCol(X), ButtonText$(X), Ingedrukt, X = Default
            NEXT X
            IF Default = Buttons + 1 THEN
                QATTR SysKnopRij, SysKnopKol, 1, 3, Kleur(17)
                LOCATE SysKnopRij, SysKnopKol + 1
            ELSEIF LDefault = Buttons + 1 THEN
                QATTR SysKnopRij, SysKnopKol, 1, 3, Kleur(16)
            END IF
            LDefault = Default
            LIngedrukt = Ingedrukt
            IF ButtonType AND 2048 THEN EXIT DO
        END IF
        IF Default = Buttons + 1 THEN
            IF MRij = SysKnopRij AND MKol >= SysKnopKol AND MKol <= SysKnopKol + 2 THEN
                LOCATE , , 0
            ELSE
                LOCATE , , 1
            END IF
        END IF
        Toets = UserInput(MRij, MKol, 0, 0, 0, 0)
        IF Toets = 257 AND FirstTime THEN Toets = 256
        SELECT CASE Toets
            CASE 9
                Default = Default + 1
                IF Default > Buttons THEN Default = 1: EXIT DO
            CASE -15
                Default = Default - 1
                IF Default < 1 THEN Default = 1: EXIT DO
            CASE -59
                EXIT DO
            CASE 256, 260
                IF MRij = SysKnopRij AND MKol >= SysKnopKol AND MKol <= SysKnopKol + 2 THEN
                    Default = Buttons + 1
                ELSE
                    FOR X = 1 TO Buttons
                        IF ButtonRow = MRij AND MKol >= BCol(X) AND MKol <= BCol(X) + LEN(ButtonText$(X)) + 3 THEN
                            Default = X
                            Ingedrukt = -1
                            EXIT FOR
                        ELSEIF X = Buttons THEN
                            EXIT DO
                        END IF
                    NEXT X
                END IF
            CASE 257
                IF Default <= Buttons OR FirstTime THEN
                    Ingedrukt = 0
                    FOR X = 1 TO Buttons
                        IF ButtonRow = MRij AND MKol >= BCol(X) AND MKol <= BCol(X) + LEN(ButtonText$(X)) + 3 THEN
                            Default = X
                            Ingedrukt = -1
                            EXIT FOR
                        END IF
                    NEXT X
                END IF
            CASE 258
                IF Ingedrukt THEN
                    SelectButton = UCASE$(ButtonText$(Default))
                    Toets = 0
                    EXIT DO
                ELSEIF Default = Buttons + 1 AND MRij = SysKnopRij AND MKol >= SysKnopKol AND MKol <= SysKnopKol + 2 THEN
                    Toets = 27
                    EXIT DO
                END IF
            CASE 13, 32
                IF Default <= Buttons THEN
                    SelectButton = UCASE$(ButtonText$(Default))
                    Toets = 0
                ELSE
                    Toets = 27
                END IF
                EXIT DO
            CASE 27
                EXIT DO
            CASE ELSE
                IF In.Pieptoon THEN PLAY "O3L63AE"
        END SELECT
        FirstTime = 0
    LOOP
    FOR X = 1 TO Buttons
        Button ButtonRow, BCol(X), ButtonText$(X), -1, 0
    NEXT X
    ButtonType = ButtonType MOD 256
    IF Default = 2 THEN
        ButtonType = ButtonType + 256
    ELSEIF Default = 3 THEN
        ButtonType = ButtonType + 512
    END IF
    QPRINT "[-]", SysKnopRij, SysKnopKol, Kleur(16)
END FUNCTION

'Verwijdert lege tekens aan het einde van een string
FUNCTION STRIP$ (St$)
    P = INSTR(St$, CHR$(0))
    IF P = 0 THEN P = LEN(St$) + 1
    STRIP = RTRIM$(LEFT$(St$, P - 1))
END FUNCTION

FUNCTION UserInput (MRij, MKol, ShiftFlag%, CtrlFlag%, AltFlag%, ErUitNa!)
    STATIC Overwrite, HavePressed, LastKey, LastMousePos, GeefToetsTerug, LastStatus, LastTimePressed!
    IF GeefToetsTerug THEN 'De meest recent ingedrukte toets
        MRij = LastMousePos MOD 128 'teruggeven
        MKol = INT(LastMousePos / 128)
        ShiftFlag = (LastStatus AND 1) = 1
        CtrlFlag = (LastStatus AND 2) = 2
        AltFlag = (LastStatus AND 4) = 4
        UserInput = LastKey
        GeefToetsTerug = 0
        EXIT FUNCTION
    END IF
    IF ErUitNa! < 0 THEN GeefToetsTerug = -1: EXIT FUNCTION
    IF ErUitNa! THEN TotTijd! = TIMER + ErUitNa!
    Toets = 0
    DO
        IF In.Muis THEN
            MMButton LeftB, RightB
            IF LeftB AND (LastStatus AND 8) = 0 THEN
                Toets = 256
                GetMouseLoc MRij, MKol
                IF TIMER - LastTimePressed! <= .3 THEN Toets = 260
                LastTimePressed! = TIMER
                LastStatus = (LastStatus OR 8)
            ELSEIF LeftB AND (LastStatus AND 8) = 8 AND ErUitNa! = 0 THEN
                Toets = 257
                GetMouseLoc MRij, MKol
            ELSEIF (LastStatus AND 8) = 8 AND ErUitNa! = 0 THEN
                Toets = 258
                GetMouseLoc MRij, MKol
                LastStatus = LastStatus XOR 8
            END IF
        END IF
        GetKbd1 LS, RS, C, a
        s = LS OR RS
        GetKbd Ins, Caps, Num, ScrollLock
        IF Overwrite XOR Ins THEN
            Overwrite = Ins
            IF Overwrite THEN
                LOCATE , , , 0, 14
            ELSE
                LOCATE , , , 12, 13
            END IF
        END IF
        IF (s AND ShiftFlag) AND (LastStatus AND 1) = 0 THEN
            LastStatus = LastStatus OR 1
            Toets = 259
        END IF
        IF (NOT s AND ShiftFlag) AND (LastStatus AND 1) = 1 THEN
            LastStatus = LastStatus XOR 1
            Toets = 261
        END IF

        IF (C AND CtrlFlag) AND (LastStatus AND 2) = 0 THEN
            LastStatus = LastStatus OR 2
            Toets = 259
        END IF
        IF (NOT C AND CtrlFlag) AND (LastStatus AND 2) = 2 THEN
            LastStatus = LastStatus XOR 2
            Toets = 261
        END IF
        IF (a AND AltFlag) AND (LastStatus AND 4) = 0 THEN
            LastStatus = LastStatus OR 4
            Toets = 259
        END IF
        IF (NOT a AND AltFlag) AND (LastStatus AND 4) = 4 THEN
            LastStatus = LastStatus XOR 4
            Toets = 261
        END IF
        K$ = INKEY$
        IF LEN(K$) THEN
            Toets = ASC(RIGHT$(K$, 1))
            IF LEN(K$) = 2 THEN Toets = -Toets
        END IF
    LOOP UNTIL Toets OR (TIMER > TotTijd! AND ErUitNa! > 0)
    ShiftFlag = s
    CtrlFlag = C
    AltFlag = a
    LastStatus = (ShiftFlag AND 1) + (CtrlFlag AND 2) + (AltFlag AND 4) + (LastStatus AND 8)
    LastMousePos = MRij + MKol * 128
    LastKey = Toets
    UserInput = Toets
END FUNCTION

