DECLARE FUNCTION OpenFileBox% (Titel$, Invoer%, FileSpec$, Filter$, HelpTpcNum%)
DECLARE FUNCTION STRIP$ (St$)
DECLARE SUB ShellSort (Array$(), Num%)
DECLARE SUB QPRINT (Text AS STRING, Row AS INTEGER, Col AS INTEGER, Attr AS INTEGER)
DECLARE SUB QATTR (Row AS INTEGER, Col AS INTEGER, Rows AS INTEGER, Cols AS INTEGER, Attr AS INTEGER)
DEFINT A-Z
TYPE MenuType
    Text AS STRING * 49
    MType AS INTEGER '1=Uitgeschakeld 2=Horizontale lijn 4=Wortel ervoor + 256*Lengte submenu's
    MsgLine AS STRING * 80
    HelpTpcNum AS INTEGER
END TYPE
DECLARE FUNCTION SelectieBox% (Title$, Choice$(), SelectieSwitch%(), Aantal%, HelpTpcNum%)
DECLARE FUNCTION UserInput% (MRij%, MKol%, Shift%, Ctrl%, Alt%, ErUitNa!)
DECLARE FUNCTION EditString$ (InString$, Legal$, Length%, Rest$, Visible%, HotKey%, Shift%, Ctrl%, Alt%, Gewijzigd%, Attr%, CurPos%, SelP%)
DECLARE FUNCTION ChangeColourSet% (Title$, HelpTpcNum%)
DECLARE SUB Button (Row%, Col%, Text$, Ingedrukt%, Default%)
DECLARE SUB HelpWindow (TpcNum%)
DECLARE SUB Expand (St$)
DECLARE SUB Panel (Row%, Col%, Hght%, Wdth%, Brdr%, Attr%)
DECLARE SUB OpenWin (Row%, Col%, Hght%, Wdth%, Attr%, Brdr%, Shdw%, Label%, Lbl$, Array%())
DECLARE SUB CloseWin (Array%())
DECLARE FUNCTION MSGBox$ (Msg$, ButtonType%, Title$, HelpTpcNum%)
DECLARE FUNCTION InputBox$ (Title$, Msg$, InString$, Legal$, Length%, Visible%, HotKey%, HelpTpcNum%)
DECLARE SUB ClipBoard (Which%, Buffer$)
DECLARE FUNCTION SelectButton$ (ButtonRow%, ButtonCol%, SysteemKnopRij%, SysteemKnopKolom%, ButtonType%, MRij%, MKol%, Toets%)
'PBCLONE
DECLARE FUNCTION CheckDsk% (Drive$)
DECLARE SUB Blink (BYVAL SetBlink%)
DECLARE SUB CursorInfo (Visible%, StartLine%, EndLine%, MaxLine%)
DECLARE FUNCTION Exist2% (FileName$)
DECLARE SUB EXTRACT (St$, Delimiter$, Index%, Start%, SLen%)
DECLARE SUB FileCount (File$, BYVAL FilAttr%, FilCount%, ErrCode%)
DECLARE FUNCTION GetCRT2% ()
DECLARE FUNCTION GetDrive$ ()
DECLARE FUNCTION GetEGA2% ()
DECLARE SUB GetKbd (Ins%, Caps%, Num%, ScrollLock%)
DECLARE SUB GetKbd1 (LShift%, RShift%, Control%, Alt%)
DECLARE SUB GetMouseLoc (Row%, Column%)
DECLARE FUNCTION GetSub2$ (Drive$)
DECLARE FUNCTION GetVGA2% ()
DECLARE SUB LoadDir (File$, BYVAL FilAttr%, BYVAL DSeg%, BYVAL DOfs%, ErrCode%)
DECLARE SUB MMButton (LeftB%, RightB%)
DECLARE SUB MMCursorOff ()
DECLARE SUB MMCursorOn ()
DECLARE SUB RInstr (MainSt$, SubSt$, Posn%)
DECLARE SUB SetBit (Number%, BYVAL BitNr%)
DECLARE SUB SetDrv (Drive$)
DECLARE SUB SetSub (SubDir$, ErrCode%)
DECLARE FUNCTION SubExist2% (SubDir$)
TYPE InitVars
    Rijen AS INTEGER
    Muis AS INTEGER
    AutoSave AS INTEGER
    Pieptoon AS INTEGER
    Schaduw AS INTEGER
    BeeldAfTijd AS INTEGER
    TekstSnel AS INTEGER
    RegelsAutomatisch AS INTEGER
END TYPE
DIM Kleur(1 TO 19)
COMMON SHARED Kleur()
COMMON SHARED In AS InitVars, HelpFile$
DIM SHARED LastError

FoutOntdekt:
    LastError = ERR
    RESUME NEXT
RETURN

'Kleuren wijzigen
FUNCTION ChangeColourSet (Title$, HelpTpcNum)
    CONST Aantal = 19, VKol = 6
    REDIM EA(1 TO Aantal), Naam$(1 TO Aantal), Background(0), KleurCode(0 TO 15)
    Naam$(1) = "Achtergrond                            "
    Naam$(2) = "Primair venster                        "
    Naam$(3) = "Veld primair venster geselecteerd      "
    Naam$(4) = "Menu                                   "
    Naam$(5) = "Menutekst geaccentueerd                "
    Naam$(6) = "Menutekst geselecteerd                 "
    Naam$(7) = "Menutekst geselecteerd/geaccentueerd   "
    Naam$(8) = "Secundair venster                      "
    Naam$(9) = "Lijst in secundair venster             "
    Naam$(10) = "Onderdeel geselecteerd                 "
    Naam$(11) = "Helpvenster                            "
    Naam$(12) = "Helptekst geaccentueerd                "
    Naam$(13) = "Andere onderwerpen in helpvenster      "
    Naam$(14) = "Andere onderwerpen geselecteerd        "
    Naam$(15) = "Titelbalk                              "
    Naam$(16) = "Veld in secundair venster              "
    Naam$(17) = "Veld in secundair venster geselecteerd "
    Naam$(18) = "Tekst uitgeschakeld (menu of venster)  "
    Naam$(19) = "Statusbalk                             "
    FOR X = 1 TO Aantal
        EA(X) = Kleur(X)
    NEXT X
    Blink 0
    Colour = GetCRT2
    IF Colour THEN
        MaxColour = 15
        Kleurentabel$ = "ABCDEFGHIJKLMNOP" 'A=Kleur 0, B=Kleur 1, etc.
    ELSE
        MaxColour = 4
        Kleurentabel$ = "ABHJP"
    END IF
    FOR X = 0 TO MaxColour
        KleurCode(X) = ASC(MID$(Kleurentabel$, X + 1)) - 65
    NEXT X
    VRij = (In.Rijen - 23) \ 2
    OpenWin VRij, VKol, 23, 69, Kleur(8), 2, In.Schaduw, Kleur(15), Title$, Background()
    QPRINT "F1=Help  Enter=Uitvoeren  Esc=Annuleren  Tab=Volgende veld  Pijl=Volgende item  ", In.Rijen, 1, Kleur(19)
    Panel VRij + 1, VKol + 48, 18, 10, 1, Kleur(8)
    Panel VRij + 1, VKol + 58, 18, 10, 1, Kleur(8)
    EditKleur = 1
    Cursor = 1
    FOR X = 0 TO MaxColour
        QPRINT SPACE$(8), VRij + 2 + X, VKol + 49, KleurCode(X) * 16 + KleurCode(X XOR MaxColour)
        QPRINT SPACE$(8), VRij + 2 + X, VKol + 59, KleurCode(X) * 16 + KleurCode(X XOR MaxColour)
    NEXT X
    GOSUB TekenKObjecten
    ButtonType = 1
    Default = 1
    SelButton$ = SelectButton(VRij + 20, VKol + 6, VRij, VKol, ButtonType + 2048, MRij, MKol, Toets)
    DO
        SELECT CASE Default
            CASE 1, 2, 3
                IF LastCursor <> Cursor OR LDefault <> Default THEN
                    GOSUB TekenKObjecten
                    IF Default = 2 THEN LOCATE VRij + 2 + Cursor, VKol + 50, 1
                    IF Default = 3 THEN LOCATE VRij + 2 + Cursor, VKol + 60, 1
                    LastCursor = Cursor
                END IF
                Toets = UserInput(MRij, MKol, 0, 0, 0, 0)
            CASE 4
                SelButton$ = SelectButton(VRij + 20, VKol + 6, VRij, VKol, ButtonType, MRij, MKol, Toets)
        END SELECT
        LDefault = Default
        SELECT CASE Toets
            CASE 9
                IF Default < 4 THEN Default = Default + 1 ELSE Default = 1
                IF Default = 1 THEN Cursor = EditKleur
                IF Default = 2 THEN
                    Y = EA(EditKleur) MOD 16
                    FOR X = 0 TO MaxColour
                        IF KleurCode(X) = Y THEN Cursor = X: EXIT FOR
                    NEXT X
                END IF
                IF Default = 3 THEN
                    Y = INT(EA(EditKleur) / 16)
                    FOR X = 0 TO MaxColour
                        IF KleurCode(X) = Y THEN Cursor = X: EXIT FOR
                    NEXT X
                END IF
            CASE -15
                IF Default > 1 THEN Default = Default - 1 ELSE Default = 4
                IF Default = 1 THEN Cursor = EditKleur
                IF Default = 2 THEN
                    Y = EA(EditKleur) MOD 16
                    FOR X = 0 TO MaxColour
                        IF KleurCode(X) = Y THEN Cursor = X: EXIT FOR
                    NEXT X
                END IF
                IF Default = 3 THEN
                    Y = INT(EA(EditKleur) / 16)
                    FOR X = 0 TO MaxColour
                        IF KleurCode(X) = Y THEN Cursor = X: EXIT FOR
                    NEXT X
                END IF
            CASE -80, -77
                IF Default = 1 THEN
                    IF Cursor < Aantal THEN Cursor = Cursor + 1 ELSE Cursor = 1
                ELSEIF Default = 2 OR Default = 3 THEN
                    IF Cursor < MaxColour THEN Cursor = Cursor + 1 ELSE Cursor = 0
                END IF
            CASE -72, -75
                IF Default = 1 THEN
                    IF Cursor > 1 THEN Cursor = Cursor - 1 ELSE Cursor = Aantal
                ELSEIF Default = 2 OR Default = 3 THEN
                    IF Cursor > 0 THEN Cursor = Cursor - 1 ELSE Cursor = MaxColour
                END IF
            CASE 27
                EXIT DO
            CASE 32, 13
                SELECT CASE Default
                    CASE 1
                        EditKleur = Cursor
                        LastCursor = -1
                    CASE 2
                        EA(EditKleur) = (EA(EditKleur) AND 240) + KleurCode(Cursor)
                        LastCursor = -1
                    CASE 3
                        EA(EditKleur) = KleurCode(Cursor) * 16 + EA(EditKleur) MOD 16
                        LastCursor = -1
                    CASE 4
                        IF SelButton$ = "HELP" THEN
                            HelpWindow HelpTpcNum
                            QPRINT "F1=Help  Enter=Uitvoeren  Esc=Annuleren  Tab=Volgende veld  Pijl=Volgende item  ", In.Rijen, 1, Kleur(19)
                        ELSEIF LEN(SelButton$) THEN
                            IF SelButton$ = "OK" THEN
                                FOR X = 1 TO Aantal
                                    Kleur(X) = EA(X)
                                NEXT X
                            END IF
                            ChangeColourSet = -1
                            EXIT DO
                        END IF
                END SELECT
            CASE -59
                HelpWindow HelpTpcNum
                QPRINT "F1=Help  Enter=Uitvoeren  Esc=Annuleren  Tab=Volgende veld  Pijl=Volgende item  ", In.Rijen, 1, Kleur(19)
            CASE 256, 260
                Default = 4
                IF MRij >= VRij + 1 AND MRij <= VRij + Aantal AND MKol <= VKol + 5 THEN Default = 1
                IF MRij > VRij + 1 AND MRij < VRij + 3 + MaxColour AND MKol > VKol + 48 AND MKol < VKol + 57 THEN Default = 2
                IF MRij > VRij + 1 AND MRij < VRij + 3 + MaxColour AND MKol > VKol + 58 AND MKol < VKol + 67 THEN Default = 3
            CASE 257
                IF Default = 1 THEN
                    FOR X = 1 TO Aantal
                        IF MRij = VRij + X AND MKol >= VKol + 3 AND MKol <= VKol + 5 THEN Cursor = X
                    NEXT X
                END IF
                IF Default = 2 THEN
                    IF MRij > VRij + 1 AND MRij < VRij + 18 AND MKol > VKol + 48 AND MKol < VKol + 57 THEN
                        Cursor = MRij - VRij - 2
                        LastCursor = -1
                        EA(EditKleur) = (EA(EditKleur) AND 240) + KleurCode(Cursor)
                    END IF
                END IF
                IF Default = 3 THEN
                    IF MRij > VRij + 1 AND MRij < VRij + 18 AND MKol > VKol + 58 AND MKol < VKol + 67 THEN
                        Default = 3
                        Cursor = MRij - VRij - 2
                        LastCursor = -1
                        EA(EditKleur) = KleurCode(Cursor) * 16 + EA(EditKleur) MOD 16
                    END IF
                END IF
            CASE 258
                IF Default = 1 THEN EditKleur = Cursor: LastCursor = -1
            CASE 0
                IF LEN(SelButton$) THEN
                    IF SelButton$ = "HELP" THEN
                        HelpWindow HelpTpcNum
                        QPRINT "F1=Help  Enter=Uitvoeren  Esc=Annuleren  Tab=Volgende veld  Pijl=Volgende item  ", In.Rijen, 1, Kleur(19)
                    ELSEIF LEN(SelButton$) THEN
                        IF SelButton$ = "OK" THEN
                            FOR X = 1 TO Aantal
                                Kleur(X) = EA(X)
                            NEXT X
                            ChangeColourSet = -1
                        END IF
                        EXIT DO
                    END IF
                END IF
            CASE ELSE
        END SELECT
    LOOP
    CloseWin Background()
    QPRINT SPACE$(80), In.Rijen, 1, Kleur(19)
    EXIT FUNCTION

TekenKObjecten:
    FOR X = 1 TO Aantal
        IF EditKleur = X THEN S$ = "()" ELSE S$ = "( )"
        QPRINT S$, VRij + X, VKol + 3, Kleur(16)
        N$ = Naam$(X)
        QPRINT N$, VRij + X, VKol + 7, EA(X)
        IF Cursor = X AND Default = 1 THEN
            IF Toets = 257 THEN
                LOCATE , , 0
            ELSE
                LOCATE VRij + X, VKol + 4, 1
            END IF
            QATTR VRij + X, VKol + 3, 1, 3, Kleur(17)
        END IF
    NEXT X
    RETURN
END FUNCTION

FUNCTION InputBox$ (Title$, Msg$, InString$, Legal$, Length, Visible, HotKey, HelpTpcNum)
    DIM Msg$(50)
    REDIM Background(0)
    DO
        P = INSTR(LP + 1, Msg$, "|")
        IF P THEN
            Msg$(Aantal) = MID$(Msg$, LP + 1, P - LP - 1)
        ELSE
            Msg$(Aantal) = MID$(Msg$, LP + 1)
        END IF
        IF LEN(Msg$(Aantal)) > Breedte THEN Breedte = LEN(Msg$(Aantal))
        LP = P
        Aantal = Aantal + 1
    LOOP WHILE P
    Breedte = Breedte + 2
    IF Breedte < Visible + 3 + LEN(Msg$(0)) THEN Breedte = Visible + 3 + LEN(Msg$(0))
    IF Breedte < 44 THEN Breedte = 44
    VRij = In.Rijen \ 2 - (Aantal + 8) \ 2   'Locatie van het venster
    VKol = 40 - (Breedte + 2) \ 2
    OpenWin VRij, VKol, Aantal + 8, Breedte + 2, Kleur(8), 2, In.Schaduw, Kleur(15), Title$, Background()
    QPRINT "F1=Help  Enter=Uitvoeren  Esc=Annuleren  Tab=Volgende veld  Pijl=Volgende item  ", In.Rijen, 1, Kleur(19)
    QPRINT Msg$(0), VRij + 2, VKol + 2, Kleur(8)
    FOR X = 1 TO Aantal
        QPRINT Msg$(X), VRij + X + 3, VKol + 2, Kleur(8)
    NEXT X
    Default = 1
    Inpt$ = InString$
    ButtonType = 1
    QPRINT LEFT$(Inpt$, Visible) + SPACE$(Visible - LEN(LEFT$(Inpt$, Visible))), VRij + 2, VKol + LEN(Msg$(0)) + 3, Kleur(16)
    SelButton$ = SelectButton(VRij + Aantal + 5, VKol + Breedte \ 2 - 21, VRij, VKol, ButtonType + 2048, MRij, MKol, Toets)
    DO
        SELECT CASE Default
            CASE 1
                SelPos = LEN(Inpt$)
                CurPos = 0
                Toets = 0
                DO
                    HotKey = -1
                    LOCATE VRij + 2, VKol + LEN(Msg$(0)) + 3
                    Shift = 0
                    Alt = 0
                    Ctrl = 0
                    Inpt$ = EditString(Inpt$, Legal$, Length, Rest$, Visible, HotKey, Shift, Ctrl, Alt, Gewijzigd, Kleur(17), CurPos, SelPos)
                    SELECT CASE HotKey
                        CASE 0
                            Toets = 13
                        CASE 1
                            Toets = 27
                        CASE 3
                            Toets = -15
                        CASE 4
                            Toets = 9
                        CASE 9
                            GetMouseLoc MRij, MKol
                            Toets = 256
                        CASE 16
                            Toets = -59
                    END SELECT
                LOOP UNTIL Toets
                QPRINT LEFT$(Inpt$, Visible) + SPACE$(Visible - LEN(LEFT$(Inpt$, Visible))), VRij + 2, VKol + LEN(Msg$(0)) + 3, Kleur(16)
                SelButton$ = ""
            CASE 2
                SelButton$ = SelectButton(VRij + Aantal + 5, VKol + Breedte \ 2 - 21, VRij, VKol, ButtonType, MRij, MKol, Toets)
        END SELECT
        SELECT CASE Toets
            CASE 9
                Default = Default + 1
                IF Default > 2 THEN Default = 1
            CASE -15
                Default = Default - 1
                IF Default < 1 THEN Default = 2
            CASE 256
                Default = 2
                IF MRij = VRij + 2 AND MKol > VKol + LEN(Msg$(0)) + 2 AND MKol < VKol + LEN(Msg$(0)) + 3 + Visible THEN Default = 1
            CASE 32, 13
                IF Default = 1 THEN GOTO EnterPressed
            CASE 27
                GOTO EscapePressed
            CASE -59
                HelpWindow HelpTpcNum
                QPRINT "F1=Help  Enter=Uitvoeren  Esc=Annuleren  Tab=Volgende veld  Pijl=Volgende item  ", In.Rijen, 1, Kleur(19)
            CASE 0
                SELECT CASE SelButton$
                    CASE "OK"
                        GOTO EnterPressed
                    CASE "ANNULEREN"
                        GOTO EscapePressed
                    CASE "HELP"
                        HelpWindow HelpTpcNum
                        QPRINT "F1=Help  Enter=Uitvoeren  Esc=Annuleren  Tab=Volgende veld  Pijl=Volgende item  ", In.Rijen, 1, Kleur(19)
                    CASE ELSE
                END SELECT
            CASE ELSE
        END SELECT
    LOOP
EscapePressed:
    Inpt$ = ""
    CloseWin Background()
    QPRINT SPACE$(80), In.Rijen, 1, Kleur(19)
    InputBox = ""
    HotKey = 1
    EXIT FUNCTION
EnterPressed:
    CloseWin Background()
    QPRINT SPACE$(80), In.Rijen, 1, Kleur(19)
    InputBox = Inpt$
    HotKey = 0
    EXIT FUNCTION
END FUNCTION

FUNCTION OpenFileBox (Titel$, Invoer, FileSpec$, Filter$, HelpTpcNum)
    CONST VKol = 5
    REDIM Bes(0) AS STRING * 12, DIR(0) AS STRING * 12, Background(0)
    STATIC LastDir$
    VRij = (In.Rijen - 21) \ 2
    CURDIR$ = GetDrive + ":" + GetSub2("")
    IF SubExist2(LastDir$) THEN
        SetDrv LastDir$
        SetSub LastDir$, ErrCode
    END IF
    FS$ = FileSpec$
    FT$ = Filter$
    ButtonType = 1
    GOSUB Reread
    FS$ = Filter$
    DO
        IF LDefault <> Default THEN
            IF LDefault = 2 THEN
                FOR X = 1 TO 24
                    QPRINT " " + Bes(X) + SPACE$(13 - LEN(Bes(X))), VRij + 8 + (X - 1) MOD 8, VKol + 3 + 14 * ((X - 1) \ 8), Kleur(9)
                NEXT X
                QPRINT STRING$(41, CHR$(176)), VRij + 16, VKol + 4, Kleur(16)
                QPRINT SPACE$(17) + "Bestanden" + SPACE$(17), VRij + 7, VKol + 3, Kleur(16)
                BBA = 1
            ELSEIF LDefault = 3 THEN
                FOR X = 1 TO 8
                    QPRINT " " + DIR(X) + SPACE$(13 - LEN(DIR(X))), VRij + 7 + X, VKol + 55, Kleur(9)
                NEXT X
                FOR X = VRij + 9 TO VRij + 14
                    QPRINT CHR$(176), X, VKol + 69, Kleur(16)
                NEXT X
                QPRINT " Dir" + CHR$(39) + "s/Drives  ", VRij + 7, VKol + 55, Kleur(16)
                FS$ = FT$
                BDA = 1
            END IF
            IF Default = 2 THEN
                QPRINT SPACE$(17) + "Bestanden" + SPACE$(17), VRij + 7, VKol + 3, Kleur(17)
                BBA = 1
                LNBA = 1
                NBA = 0
                LBBA = 0
            ELSEIF Default = 3 THEN
                QPRINT " Dir" + CHR$(39) + "s/Drives  ", VRij + 7, VKol + 55, Kleur(17)
                BDA = 1
                LNDA = 1
                NDA = 0
                LBDA = 0
            END IF
            LDefault = Default
        END IF
        SELECT CASE Default
            CASE 1
                SelPos = LEN(FS$)
                CurPos = 0
                Toets = 0
                DO
                    HotKey = -1
                    Shift = 0
                    Alt = 0
                    Ctrl = 0
                    LOCATE VRij + 2, VKol + 16
                    FS$ = EditString(FS$, "", 255, Rest$, 53, HotKey, Shift, Ctrl, Alt, Gewijzigd, Kleur(17), CurPos, SelPos)
                    SELECT CASE HotKey
                        CASE 0
                            Toets = 13
                        CASE 1
                            Toets = 27
                        CASE 3
                            Toets = -15
                        CASE 4
                            Toets = 9
                        CASE 9
                            Toets = 256
                            GetMouseLoc MRij, MKol
                        CASE 16
                            Toets = -59
                    END SELECT
                LOOP UNTIL Toets
                QPRINT LEFT$(FS$, 53) + SPACE$(53 - LEN(LEFT$(FS$, 53))), VRij + 2, VKol + 16, Kleur(16)
            CASE 2
                IF NBA <> LNBA THEN
                    IF NBA = 0 THEN LOCATE VRij + 8, VKol + 4, 1
                    IF BAantal THEN
                        K = LNBA / BAantal * 40 + VKol + 4
                        QATTR VRij + 16, K, 1, 1, Kleur(16)
                        K = NBA / BAantal * 40 + VKol + 4
                        QATTR VRij + 16, K, 1, 1, Kleur(17)
                    END IF
                END IF
                IF BBA <> LBBA THEN
                    BA = BBA + 23
                    IF BA > 512 THEN BA = 512
                    FOR X = BBA TO BA
                        QPRINT " " + Bes(X) + SPACE$(13 - LEN(Bes(X))), VRij + 8 + (X - BBA) MOD 8, VKol + 3 + 14 * ((X - BBA) \ 8), Kleur(9)
                    NEXT X
                    LBBA = BBA
                ELSEIF NBA <> LNBA AND LNBA > 0 THEN
                    QPRINT " " + Bes(LNBA) + SPACE$(13 - LEN(Bes(LNBA))), VRij + 8 + (LNBA - BBA) MOD 8, VKol + 3 + 14 * ((LNBA - BBA) \ 8), Kleur(9)
                END IF
                IF NBA >= 1 AND NBA <> LNBA THEN
                    QPRINT " " + Bes(NBA) + SPACE$(13 - LEN(Bes(NBA))), VRij + 8 + (NBA - BBA) MOD 8, VKol + 3 + 14 * ((NBA - BBA) \ 8), Kleur(10)
                    LOCATE VRij + 8 + (NBA - BBA) MOD 8, VKol + 4 + 14 * INT((NBA - BBA) / 8), 1
                    FS$ = LTRIM$(RTRIM$(Bes(NBA)))
                    QPRINT FS$ + SPACE$(53 - LEN(FS$)), VRij + 2, VKol + 16, Kleur(16)
                END IF
                LNBA = NBA
                Toets = UserInput(MRij, MKol, 0, 0, 0, 0)
            CASE 3
                IF LNDA <> NDA THEN
                    DA = BDA + 7
                    IF NDA = 0 THEN LOCATE VRij + 8, VKol + 56, 1
                    FOR X = BDA TO DA
                        IF X = NDA THEN
                            QPRINT " " + DIR(X) + SPACE$(13 - LEN(DIR(X))), VRij + 8 + X - BDA, VKol + 55, Kleur(10)
                            LOCATE VRij + 8 + X - BDA, VKol + 56
                        ELSE
                            QPRINT " " + DIR(X) + SPACE$(13 - LEN(DIR(X))), VRij + 8 + X - BDA, VKol + 55, Kleur(9)
                        END IF
                    NEXT X
                    IF NOT NDA <= 0 THEN
                        D$ = LTRIM$(RTRIM$(DIR(NDA)))
                        IF LEFT$(D$, 2) = "[-" THEN
                            FS$ = MID$(D$, 3, 1) + ":" + FT$
                        ELSEIF D$ = ".." THEN
                            FS$ = ".." + FT$
                        ELSE
                            FS$ = LTRIM$(RTRIM$(DIR(NDA))) + "\" + FT$
                        END IF
                        QPRINT FS$ + SPACE$(53 - LEN(FS$)), VRij + 2, VKol + 16, Kleur(16)
                    END IF
                    LNDA = NDA
                    QATTR VRij + 9, VKol + 69, 6, 1, Kleur(16)
                    IF CINT((NDA / DAantal * 6)) THEN
                        QATTR VRij + 8 + NDA / DAantal * 6, VKol + 69, 1, 1, Kleur(17)
                    ELSE
                        QATTR VRij + 9, VKol + 69, 1, 1, Kleur(17)
                    END IF
                END IF
                Toets = UserInput(MRij, MKol, 0, 0, 0, 0)
            CASE 4
                SelButton$ = SelectButton(VRij + 18, VKol + 13, VRij, VKol, ButtonType, MRij, MKol, Toets)
        END SELECT
        SELECT CASE Toets
            CASE 9
                Default = Default + 1
                IF BAantal = 0 AND Default = 2 THEN Default = Default + 1
                IF Default > 4 THEN Default = 1
            CASE -15
                Default = Default - 1
                IF BAantal = 0 AND Default = 2 THEN Default = Default - 1
                IF Default < 1 THEN Default = 4
            CASE -77
                IF Default = 2 THEN
                    IF NBA + 8 <= BAantal THEN
                        NBA = NBA + 8
                        IF NBA > BBA + 23 THEN BBA = BBA + 8
                    ELSE
                        NBA = BAantal
                        IF NBA > BBA + 23 THEN BBA = BBA + 8
                    END IF
                ELSEIF Default = 3 THEN
                    IF NDA < DAantal THEN
                        NDA = NDA + 1
                        IF NDA > BDA + 7 THEN IF BDA + 7 < DAantal THEN BDA = BDA + 1 ELSE NDA = NDA - 1
                    END IF
                END IF
            CASE -75
                IF Default = 2 THEN
                    IF NBA - 8 >= 1 THEN
                        NBA = NBA - 8
                        IF NBA < BBA THEN IF BBA > 8 THEN BBA = BBA - 8 ELSE NBA = NBA + 8
                    ELSE
                        NBA = 1
                        BBA = 1
                    END IF
                ELSEIF Default = 3 THEN
                    IF NDA > 1 THEN
                        NDA = NDA - 1
                        IF NDA < BDA THEN IF BDA >= 1 THEN BDA = BDA - 1 ELSE NDA = NDA + 1
                    END IF
                END IF
            CASE -80
                IF Default = 2 THEN
                    IF NBA + 1 <= BAantal THEN
                        NBA = NBA + 1
                        IF NBA > BBA + 23 THEN BBA = BBA + 8
                    END IF
                ELSEIF Default = 3 THEN
                    IF NDA < DAantal THEN
                        NDA = NDA + 1
                        IF NDA > BDA + 7 THEN IF BDA + 7 < DAantal THEN BDA = BDA + 1 ELSE NDA = NDA - 1
                    END IF
                END IF
            CASE -72
                IF Default = 2 THEN
                    IF NBA - 1 >= 1 THEN
                        NBA = NBA - 1
                        IF NBA < BBA THEN IF BBA > 7 THEN BBA = BBA - 7 ELSE BBA = NBA
                    END IF
                ELSEIF Default = 3 THEN
                    IF NDA > 1 THEN
                        NDA = NDA - 1
                        IF NDA < BDA THEN IF BDA >= 1 THEN BDA = BDA - 1 ELSE NDA = NDA + 1
                    END IF
                END IF
            CASE 32
                IF Default = 4 THEN GOTO Escape
            CASE 13
                IF Default = 4 THEN GOTO Escape
                IF Default = 1 THEN GOSUB Enter
                IF Default = 2 THEN
                    IF NBA = 0 THEN
                        Default = 1
                    ELSE
                        GOSUB Enter
                    END IF
                ELSEIF Default = 3 THEN
                    Default = 1
                    IF NDA THEN GOSUB Enter
                END IF
            CASE 27
                GOTO Escape
            CASE 256, 260
                Default = 4
                IF MKol = VKol + 69 AND MRij >= VRij + 8 AND MRij <= VRij + 15 THEN Default = 3
                IF MRij > VRij + 1 AND MRij < VRij + 4 AND MKol > VKol + 15 AND MKol < VKol + 69 THEN Default = 1
                IF BAantal THEN
                    IF MRij = VRij + 16 AND MKol >= VKol + 3 AND MKol <= VKol + 45 THEN Default = 2
                    IF MRij >= VRij + 7 AND MRij <= VRij + 15 AND MKol >= VKol + 3 AND MKol <= VKol + 45 THEN
                        Default = 2
                        BA = BBA + 23
                        IF BA > BAantal THEN BA = BAantal
                        FOR X = BBA TO BA
                            IF MRij = VRij + 8 + (X - BBA) MOD 8 AND MKol >= VKol + 3 + 14 * ((X - BBA) \ 8) AND MKol <= 21 + 14 * INT((X - BBA) / 8) THEN
                                IF Toets = 260 AND NBA = X THEN GOSUB Enter ELSE NBA = X
                                EXIT FOR
                            ELSEIF X = BA THEN
                                NBA = 0
                            END IF
                        NEXT X
                    END IF
                END IF
                IF MRij >= VRij + 7 AND MRij <= VRij + 16 AND MKol >= VKol + 55 AND MKol <= VKol + 69 THEN
                    Default = 3
                    DA = BDA + 7
                    IF DA > DAantal THEN DA = DAantal
                    FOR X = BDA TO DA
                        IF MRij = VRij + 8 + X - BDA AND MKol > VKol + 54 AND MKol < VKol + 69 THEN
                            IF Toets = 260 AND NDA = X THEN
                                Default = 1
                                GOSUB Enter
                            ELSE
                                NDA = X
                            END IF
                            EXIT FOR
                        ELSEIF X = DA THEN
                            NDA = 0
                        END IF
                    NEXT X
                END IF
                WachtTijd! = 0
            CASE 257
                IF Default = 2 THEN
                    IF MRij > VRij + 7 AND MRij < VRij + 17 AND MKol > VKol + 2 AND MKol < VKol + 45 THEN
                        BA = BBA + 23
                        IF BA > BAantal THEN BA = BAantal
                        FOR X = BBA TO BA
                            IF MRij = VRij + 8 + (X - BBA) MOD 8 AND MKol >= VKol + 3 + 14 * ((X - BBA) \ 8) AND MKol <= VKol + 16 + 14 * INT((X - BBA) / 8) THEN
                                NBA = X
                                EXIT FOR
                            END IF
                        NEXT X
                    END IF
                    IF TIMER - WachtTijd! >= .05 OR WachtTijd! = 0 THEN
                        WachtTijd! = TIMER
                        IF MKol < VKol + 2 THEN
                            IF NBA >= 9 THEN
                                NBA = NBA - 8
                                IF NBA < BBA THEN IF BBA > 8 THEN BBA = BBA - 8 ELSE BBA = 1
                            ELSE
                                NBA = 1
                                BBA = 1
                            END IF
                        ELSEIF MKol >= VKol + 46 THEN
                            IF NBA + 8 <= BAantal THEN
                                NBA = NBA + 8
                                IF NBA > BBA + 23 THEN BBA = BBA + 8
                            ELSE
                                NBA = BAantal
                                IF NBA > BBA + 23 THEN BBA = BBA + 8
                            END IF
                        ELSEIF MRij < VRij + 7 THEN
                            IF NBA > 1 THEN
                                NBA = NBA - 1
                                IF NBA < BBA THEN IF BBA > 7 THEN BBA = BBA - 7 ELSE BBA = NBA
                            END IF
                        ELSEIF MRij >= VRij + 17 THEN
                            IF NBA < BAantal THEN
                                NBA = NBA + 1
                                IF NBA > BBA + 23 THEN BBA = BBA + 8
                            END IF
                        END IF
                        K! = NBA / BAantal * 40 + VKol + 4
                        IF MRij = VRij + 16 AND MKol >= VKol + 3 AND MKol < K! THEN
                            IF NBA > 1 THEN NBA = NBA - 1
                            IF BBA > 1 THEN BBA = BBA - 1
                        ELSEIF MRij = VRij + 16 AND MKol > K! AND MKol <= VKol + 45 THEN
                            IF NBA = 0 THEN NBA = 1
                            IF NBA < BAantal THEN NBA = NBA + 1
                            IF BBA < BAantal - 23 THEN BBA = BBA + 1
                        END IF
                    END IF
                ELSEIF Default = 3 THEN
                    IF MRij > VRij + 7 AND MRij <= VRij + 15 AND MKol > VKol + 54 AND MKol < VKol + 69 THEN
                        DA = BDA + 7
                        IF DA > DAantal THEN DA = DAantal
                        FOR X = BDA TO DA
                            IF MRij = VRij + 8 + X - BDA THEN
                                NDA = X
                                EXIT FOR
                            END IF
                        NEXT X
                    END IF
                    IF TIMER - WachtTijd! >= .05 OR WachtTijd! = 0 THEN
                        WachtTijd! = TIMER
                        K! = VRij + 9 + NDA / DAantal * 5
                        IF MRij >= VRij + 17 THEN
                            IF NDA < DAantal THEN
                                NDA = NDA + 1
                                IF NDA > BDA + 7 THEN IF BDA + 7 < DAantal THEN BDA = BDA + 1 ELSE NDA = NDA - 1
                            END IF
                        ELSEIF MRij <= VRij + 6 THEN
                            IF NDA > 1 THEN
                                NDA = NDA - 1
                                IF NDA < BDA THEN IF BDA >= 1 THEN BDA = BDA - 1 ELSE BDA = 1
                            END IF
                        ELSEIF MKol = VKol + 69 AND MRij >= VRij + 8 AND MRij < K! THEN
                            IF BDA > 1 THEN
                                BDA = BDA - 1
                                IF NDA > BDA + 7 THEN NDA = BDA + 7
                            ELSEIF NDA > 1 THEN
                                NDA = NDA - 1
                                IF NDA < BDA THEN BDA = NDA
                            END IF
                        ELSEIF MKol = VKol + 69 AND MRij > K! AND MRij <= VRij + 15 THEN
                            IF BDA < DAantal - 7 THEN
                                BDA = BDA + 1
                                IF NDA < BDA THEN NDA = BDA
                            ELSEIF NDA < DAantal THEN
                                NDA = NDA + 1
                            END IF
                        END IF
                    END IF
                END IF
            CASE -59
                HelpWindow HelpTpcNum
                QPRINT "F1=Help  Enter=Uitvoeren  Esc=Annuleren  Tab=Volgende veld  Pijl=Volgende item  ", In.Rijen, 1, Kleur(19)
            CASE 0
                SELECT CASE SelButton$
                    CASE "OK"
                        GOSUB Enter
                    CASE "ANNULEREN"
                        GOTO Escape
                    CASE "HELP"
                        HelpWindow HelpTpcNum
                        QPRINT "F1=Help  Enter=Uitvoeren  Esc=Annuleren  Tab=Volgende veld  Pijl=Volgende item  ", In.Rijen, 1, Kleur(19)
                END SELECT
        END SELECT
    LOOP

Reread:
    QPRINT "Even wachten alsjeblieft" + SPACE$(61), In.Rijen, 1, Kleur(19)
    DAantal = -1
    Default = 1
    FileCount "*.*", -16, DAantal, ErrCode
    IF ErrCode = 0 THEN
        REDIM DIR(1 TO DAantal + 26) AS STRING * 12
        LoadDir "*.*", -16, VARSEG(DIR(1)), VARPTR(DIR(1)), ErrCode
        IF RTRIM$((DIR(1))) = "." THEN
            FOR X = 2 TO DAantal
                DIR(X - 1) = DIR(X)
            NEXT X
            DAantal = DAantal - 1
        END IF
        Span = DAantal \ 2
        DO WHILE Span > 0
            FOR I = Span TO DAantal - 1
                J = I - Span + 1
                FOR J = (I - Span + 1) TO 1 STEP -Span
                    IF DIR(J) <= DIR(J + Span) THEN EXIT FOR
                    SWAP DIR(J), DIR(J + Span)
                NEXT J
            NEXT I
            Span = Span \ 2
        LOOP
        FileCount FT$, 0, BAantal, ErrCode
        REDIM Bes(1 TO BAantal + 24) AS STRING * 12
        LoadDir FT$, 0, VARSEG(Bes(1)), VARPTR(Bes(1)), ErrCode
        Span = BAantal \ 2
        DO WHILE Span > 0
            FOR I = Span TO BAantal - 1
                J = I - Span + 1
                FOR J = (I - Span + 1) TO 1 STEP -Span
                    IF Bes(J) <= Bes(J + Span) THEN EXIT FOR
                    SWAP Bes(J), Bes(J + Span)
                NEXT J
            NEXT I
            Span = Span \ 2
        LOOP
    ELSE
        DAantal = 0
        REDIM DIR(1 TO 26) AS STRING * 12
        BAantal = 0
        REDIM Bes(1 TO 24) AS STRING * 12
    END IF
    DIR(DAantal + 1) = "[-A-]"
    DIR(DAantal + 2) = "[-B-]"
    DAantal = DAantal + 2
    FOR I = 3 TO 26
        IF SubExist2(CHR$(I + 64) + ":") THEN
            DAantal = DAantal + 1
            DIR(DAantal) = "[-" + CHR$(I + 64) + "-]"
        END IF
    NEXT I
    IF UBOUND(Background) = 0 THEN   'Venster is nog niet op scherm
        OpenWin VRij, VKol, 21, 72, Kleur(8), 2, In.Schaduw, Kleur(15), Titel$, Background()
        SelButton$ = SelectButton(VRij + 18, VKol + 13, VRij, 5, ButtonType + 2048, MRij, MKol, Toets)
        QPRINT "Bestandsnaam:", VRij + 2, VKol + 2, Kleur(8)
        QATTR VRij + 8, VKol + 4, 9, 42, Kleur(9)
        QATTR VRij + 8, VKol + 55, 9, 15, Kleur(9)
        IF In.Schaduw THEN
            QPRINT STRING$(43, 223), VRij + 17, VKol + 4, Kleur(8) AND 240
            QPRINT STRING$(15, 223), VRij + 17, VKol + 56, Kleur(8) AND 240
            QPRINT "", VRij + 7, VKol + 46, Kleur(8) AND 240
            QPRINT "", VRij + 7, VKol + 70, Kleur(8) AND 240
            FOR X = VRij + 8 TO VRij + 16
                QPRINT "", X, VKol + 46, Kleur(8) AND 240
                QPRINT "", X, VKol + 70, Kleur(8) AND 240
            NEXT X
        END IF
        QPRINT SPACE$(17) + "Bestanden" + SPACE$(17), VRij + 7, VKol + 3, Kleur(16)
        QPRINT " Dir" + CHR$(39) + "s/Drives  ", VRij + 7, VKol + 55, Kleur(16)
        QPRINT CHR$(27) + STRING$(41, CHR$(176)) + CHR$(26), VRij + 16, VKol + 3, Kleur(16)
        QPRINT CHR$(24), VRij + 8, VKol + 69, Kleur(16)
        QPRINT CHR$(25), VRij + 15, VKol + 69, Kleur(16)
        FOR X = VRij + 9 TO VRij + 14
            QPRINT CHR$(176), X, VKol + 69, Kleur(16)
        NEXT X
    END IF
    IF BAantal = 0 THEN
        QATTR VRij + 7, VKol + 3, 1, 43, (Kleur(18) MOD 16) + (Kleur(16) AND 240)
        QATTR VRij + 16, VKol + 3, 1, 43, (Kleur(18) MOD 16) + (Kleur(16) AND 240)
    ELSE
        QATTR VRij + 7, VKol + 3, 1, 43, Kleur(16)
        QATTR VRij + 16, VKol + 3, 1, 43, Kleur(16)
    END IF
    P$ = GetDrive + ":"
    IF ErrCode = 0 THEN P$ = P$ + GetSub2("")
    QPRINT SPACE$(65), VRij + 5, VKol + 4, Kleur(8)
    QPRINT SPACE$(65), VRij + 6, VKol + 5, Kleur(8)
    QPRINT P$, VRij + 5, VKol + 4, Kleur(9)
    IF In.Schaduw THEN
        QPRINT STRING$(LEN(P$), 223), VRij + 6, VKol + 5, Kleur(8) AND 240
        QPRINT CHR$(220), VRij + 5, VKol + 4 + LEN(P$), Kleur(8) AND 240
    END IF
    FOR X = 1 TO 24
        QPRINT " " + Bes(X), VRij + 8 + (X - 1) MOD 8, VKol + 3 + 14 * ((X - 1) \ 8), Kleur(9)
    NEXT X
    FOR X = 1 TO 8
        QPRINT " " + DIR(X), VRij + 7 + X, VKol + 55, Kleur(9)
    NEXT X
    QPRINT "F1=Help  Enter=Uitvoeren  Esc=Annuleren  Tab=Volgende veld  Pijl=Volgende item  ", In.Rijen, 1, Kleur(19)
    RETURN

Escape:
    OpenFileBox = 0
    LastDir$ = GetDrive + ":" + GetSub2("")
    SetSub CURDIR$, ErrCode
    SetDrv CURDIR$
    CloseWin Background()
    QPRINT SPACE$(80), In.Rijen, 1, Kleur(19)
    EXIT FUNCTION

Enter:
    RInstr FS$, "\", P
    IF P = 0 THEN RInstr FS$, ":", P
    Path$ = LEFT$(FS$, P)
    FS$ = MID$(FS$, P + 1)
    IF LEFT$(FS$, 2) = ".." THEN Path$ = Path$ + "..": FS$ = MID$(FS$, 3)
    IF SubExist2(Path$ + FS$) THEN
        Path$ = Path$ + FS$
        FS$ = ""
    END IF
    IF INSTR(FS$, "*") > 0 OR INSTR(FS$, "?") > 0 OR (FS$ = "" AND Path$ <> "") OR RIGHT$(Path$, 2) = ".." THEN
        Drive$ = UCASE$(LEFT$(Path$, INSTR(Path$, ":")))
        DIR$ = MID$(Path$, INSTR(Path$, ":") + 1)
        IF CheckDsk(Drive$) = 0 THEN
            IF LEN(Drive$) THEN SetDrv Drive$
            IF LEN(DIR$) THEN
                IF RIGHT$(DIR$, 1) = "\" THEN D$ = D$ + "." ELSE D$ = DIR$
                SetSub D$, ErrCode
                IF ErrCode THEN
                    IF In.Pieptoon THEN PLAY "O3L63AE"
                    Antwrd$ = MSGBox(DIR$ + " is een ongeldige directory", 0, "Fout", 0)
                    QPRINT "F1=Help  Enter=Uitvoeren  Esc=Annuleren  Tab=Volgende veld  Pijl=Volgende item  ", In.Rijen, 1, Kleur(19)
                END IF
            END IF
            IF FS$ <> "" THEN FT$ = FS$
            GOSUB Reread
        END IF
    ELSEIF FS$ = "" AND Path$ = "" THEN
        IF In.Pieptoon THEN PLAY "O3L63AE"
        Antwrd$ = MSGBox("Je moet een bestandsnaam invoeren!", 0, "Fout", 0)
        QPRINT "F1=Help  Enter=Uitvoeren  Esc=Annuleren  Tab=Volgende veld  Pijl=Volgende item  ", In.Rijen, 1, Kleur(19)
    ELSE
        FS$ = UCASE$(FS$)
        P = INSTR(FT$, ".")
        IF P > 0 AND INSTR(FS$, ".") = 0 THEN FS$ = FS$ + "." + MID$(FT$, P + 1)
        IF Exist2(Path$ + FS$) THEN
            IF Invoer THEN
                A$ = MSGBox("Het bestand " + FS$ + " bestaat al.|Wil je dit bestand vervangen?", 4, Titel$, 0)
                IF NOT A$ = "JA" THEN RETURN
            END IF
            Drive$ = LEFT$(Path$, INSTR(Path$, ":"))
            DIR$ = MID$(Path$, INSTR(Path$, ":") + 1)
            IF LEN(Drive$) THEN SetDrv Drive$ ELSE Drive$ = GetDrive$ + ":"
            IF LEN(DIR$) THEN
                IF LEFT$(DIR$, 1) = "\" THEN DIR$ = Drive$ + DIR$
                IF RIGHT$(DIR$, 1) = "\" THEN DIR$ = DIR$ + "."
                SetSub DIR$, ErrCode
            END IF
            FileSpec$ = GetDrive + ":" + GetSub2("")
            IF RIGHT$(FileSpec$, 1) <> "\" THEN FileSpec$ = FileSpec$ + "\"
            FileSpec$ = FileSpec$ + FS$
            OpenFileBox = -1
            LastDir$ = GetDrive + ":" + GetSub2("")
            SetSub CURDIR$, ErrCode
            SetDrv CURDIR$
            CloseWin Background()
            QPRINT SPACE$(80), In.Rijen, 1, Kleur(19)
            EXIT FUNCTION
        ELSEIF Invoer THEN
            LastError = 0
            ON ERROR GOTO FoutOntdekt
            NAME Path$ + FS$ AS Path$ + FS$
            ON ERROR GOTO 0
            IF LastError = 64 THEN
                A$ = MSGBox(Path$ + FS$ + " is een ongeldige bestandsnaam!", 0, Titel$, 0)
                RETURN
            END IF
            Drive$ = LEFT$(Path$, INSTR(Path$, ":"))
            DIR$ = MID$(Path$, INSTR(Path$, ":") + 1)
            IF LEN(Drive$) THEN SetDrv Drive$ ELSE Drive$ = GetDrive$ + ":"
            IF LEN(DIR$) THEN
                IF LEFT$(DIR$, 1) = "\" THEN DIR$ = Drive$ + DIR$
                IF RIGHT$(DIR$, 1) = "\" THEN DIR$ = DIR$ + "."
                SetSub DIR$, ErrCode
            END IF
            FileSpec$ = GetDrive + ":" + GetSub2("")
            IF RIGHT$(FileSpec$, 1) <> "\" THEN FileSpec$ = FileSpec$ + "\"
            FileSpec$ = FileSpec$ + FS$
            OpenFileBox = -1
            LastDir$ = GetDrive + ":" + GetSub2("")
            SetSub CURDIR$, ErrCode
            SetDrv CURDIR$
            CloseWin Background()
            QPRINT SPACE$(80), In.Rijen, 1, Kleur(19)
            EXIT FUNCTION
        ELSE
            IF In.Pieptoon THEN PLAY "O3L63AE"
            Antwrd$ = MSGBox("Bestand niet gevonden!", 0, "Fout", 0)
            QPRINT "F1=Help  Enter=Uitvoeren  Esc=Annuleren  Tab=Volgende veld  Pijl=Volgende item  ", In.Rijen, 1, Kleur(19)
        END IF
    END IF
    RETURN
END FUNCTION

SUB PullDownMenu (Menu() AS MenuType, MaxChoice, HorChoice, VerChoice, MenuRij, MenuKol)
    CONST FRM = 1 'Stel kader standaard op enkele lijn in
    CONST AltCodes$ = "2DB4&567+89:FE,-$'3(*C%A)@" 'Deze ASCII-code's min 20 zijn
    REDIM Background(0)   'de ALT-code's voor de letters A-Z
    FirstTime = -1
    QPRINT Menu(0, 0).MsgLine, In.Rijen, 1, Kleur(19)
    IF HorChoice = -1 OR VerChoice = -1 THEN
        MenuOpen = 1
        GOSUB Menubalk
        EXIT SUB
    END IF
    CursorInfo Visible, X, X, X
    LOCATE , , 0
    GOSUB Menubalk
    GetKbd1 P, P, P, FAlt
    IF HorChoice <= 0 THEN HorChoice = 1
    IF NOT FAlt THEN Toets = UserInput(0, 0, 0, 0, 0, -1)
    IF VerChoice > 0 THEN GOSUB Submenu
    DO
        Toets = UserInput(MRij, MKol, 0, 0, -1, 0)
        IF Toets = 261 AND FAlt THEN FAlt = 0: Toets = 0
        SELECT CASE Toets
            CASE 0, 259
            CASE 13
                IF MenuOpen > 0 AND VerChoice > 0 AND NOT Menu(HorChoice, VerChoice).MType AND 1 THEN
                    CloseWin Background()
                    EXIT DO
                ELSEIF VerChoice = 0 THEN
                    GOSUB Submenu
                ELSEIF In.Pieptoon THEN
                    PLAY "O3L63AE"
                END IF
            CASE -75
                HorChoice = HorChoice - 1
                IF HorChoice < 1 THEN HorChoice = MaxChoice
                IF HorChoice < 1 THEN HorChoice = MaxChoice
                IF MenuOpen THEN GOSUB Submenu
            CASE -77
                HorChoice = HorChoice + 1
                IF HorChoice > MaxChoice THEN HorChoice = 1
                IF MenuOpen THEN GOSUB Submenu
            CASE -72
                IF MenuOpen = 0 THEN
                    IF Menu(HorChoice, 0).MType AND 1 THEN IF In.Pieptoon THEN PLAY "O3L63AE"
                    GOSUB Submenu
                    VerChoice = 0
                END IF
                IF MenuOpen THEN
                    IF VerChoice <= 1 THEN
                        IF VerChoice < 1 THEN VerChoice = 1 ELSE VerChoice = INT(Menu(HorChoice, 0).MType / 256)
                    ELSE
                        DO
                            VerChoice = VerChoice - 1
                        LOOP WHILE Menu(HorChoice, VerChoice).MType AND 2
                    END IF
                END IF
            CASE -80
                IF MenuOpen = 0 THEN
                    IF Menu(HorChoice, 0).MType AND 1 THEN IF In.Pieptoon THEN PLAY "O3L63AE"
                    GOSUB Submenu
                    VerChoice = 0
                END IF
                IF MenuOpen THEN
                    IF VerChoice = INT(Menu(HorChoice, 0).MType / 256) THEN
                        VerChoice = 1
                    ELSE
                        DO
                            VerChoice = VerChoice + 1
                        LOOP WHILE Menu(HorChoice, VerChoice).MType AND 2
                    END IF
                END IF
            CASE 256, 260 'Linker muisknop werd ingedrukt
                IF MRij = MenuRij THEN
                    VerChoice = 0
                    MK = MenuKol
                    F = 0
                    FOR X = 1 TO MaxChoice
                        MK = MK + LEN(RTRIM$(Menu(X, 0).Text)) + 1
                        IF MKol >= MenuKol AND MKol < MK THEN
                            IF MenuOpen = X THEN
                                LMouseClick = HorChoice
                            ELSE
                                LMouseClick = 0
                            END IF
                            HorChoice = X
                            F = -1  'Muis heeft een menugekozen
                            EXIT FOR
                        END IF
                    NEXT X
                    IF F = -1 AND NOT HorChoice = MenuOpen THEN
                        GOSUB Submenu
                    ELSEIF F = 0 THEN
                        IF MenuOpen THEN CloseWin Background()
                        MenuOpen = 0
                        HorChoice = 0
                        EXIT DO
                    END IF
                ELSEIF MRij >= MenuRij + 2 AND MRij <= MenuRij + 1 + INT(Menu(HorChoice, 0).MType / 256) AND MenuOpen > 0 AND MKol > BoxKol AND MKol < BoxKol + MBreedte + 3 THEN
                    IF Menu(HorChoice, MRij - MenuRij - 1).MType AND 2 THEN VerChoice = 0 ELSE VerChoice = MRij - MenuRij - 1
                ELSE
                    IF MenuOpen THEN CloseWin Background()
                    HorChoice = 0
                    VerChoice = 0
                    EXIT DO
                END IF
            CASE 257, 258'Linker muisknop is ingedrukt
                IF MRij = MenuRij THEN
                    VerChoice = 0
                    MK = MenuKol
                    F = 0
                    FOR X = 1 TO MaxChoice
                        IF MKol >= MK AND MKol < MK + LEN(RTRIM$(Menu(X, 0).Text)) + 1 THEN
                            HorChoice = X
                            F = -1  'Muis heeft een menugekozen
                            EXIT FOR
                        END IF
                        MK = MK + LEN(RTRIM$(Menu(X, 0).Text)) + 1
                    NEXT X
                    IF F = -1 AND NOT HorChoice = MenuOpen THEN
                        GOSUB Submenu
                        LMouseClick = 0
                        VerChoice = 0
                    ELSEIF F = 0 OR (Menu(HorChoice, 0).MType AND 1) = 1 THEN
                        HorChoice = 0
                        IF MenuOpen THEN
                            CloseWin Background()
                            LMouseClick = 0
                            MenuOpen = 0
                            GOSUB Menubalk
                        END IF
                    END IF
                ELSEIF MenuOpen > 0 AND MRij >= MenuRij + 2 AND MRij <= MenuRij + 1 + INT(Menu(HorChoice, 0).MType / 256) AND MKol > BoxKol AND MKol < BoxKol + MBreedte + 3 THEN
                    LMouseClick = 0
                    IF Menu(HorChoice, MRij - MenuRij - 1).MType AND 2 THEN VerChoice = 0 ELSE VerChoice = MRij - MenuRij - 1
                ELSE
                    IF MRij < MenuRij AND MenuOpen > 0 THEN
                        HorChoice = 0
                        CloseWin Background()
                        LMouseClick = 0
                        MenuOpen = 0
                        GOSUB Menubalk
                    END IF
                    VerChoice = 0
                END IF
                IF Toets = 258 THEN
                    IF HorChoice = 0 THEN VerChoice = 0: EXIT DO
                    IF MenuOpen THEN
                        IF (LMouseClick = HorChoice) OR HorChoice = 0 THEN
                            CloseWin Background()
                            HorChoice = 0
                            VerChoice = 0
                            EXIT DO
                        ELSEIF VerChoice = 0 THEN
                            IF MRij > MenuRij THEN
                                CloseWin Background()
                                HorChoice = 0
                                EXIT DO
                            ELSE
                                VerChoice = 1
                                WHILE Menu(HorChoice, VerChoice).MType AND 2
                                    VerChoice = VerChoice + 1
                                WEND
                            END IF
                        ELSEIF HorChoice > 0 AND VerChoice > 0 THEN
                            IF Menu(HorChoice, VerChoice).MType AND 1 THEN
                                IF In.Pieptoon THEN PLAY "O3L63AE"
                            ELSE
                                CloseWin Background()
                                EXIT DO
                            END IF
                        END IF
                    ELSEIF In.Pieptoon THEN
                        PLAY "O3L63AE"
                    END IF
                    LMouseClick = 0
                END IF
            CASE -59
                IF MenuOpen THEN
                    IF NOT VerChoice = 0 THEN
                        HelpWindow Menu(HorChoice, VerChoice).HelpTpcNum
                        LVerChoice = 0 'MsgLine moet opnieuw neergezet worden
                    END IF
                ELSEIF NOT HorChoice = 0 THEN
                    HelpWindow Menu(HorChoice, 0).HelpTpcNum
                    LHorChoice = 0
                END IF
            CASE 261, 27, -68
                IF MenuOpen = 0 THEN
                    HorChoice = 0
                    VerChoice = 0
                    EXIT DO
                ELSE
                    CloseWin Background()
                    LMouseClick = 0
                    LHorChoice = 0
                    MenuOpen = 0
                    GOSUB Menubalk
                END IF
            CASE ELSE
                IF Toets >= -113 AND Toets <= -104 AND FAlt THEN
                    Toets = UserInput(0, 0, 0, 0, 0, -1)
                    HorChoice = 0
                    VerChoice = 0
                    EXIT DO
                END IF
                IF Toets >= 128 AND FAlt THEN
                    Toets = UserInput(0, 0, 0, 0, 0, -1)
                    HorChoice = 0
                    VerChoice = 0
                    EXIT DO
                END IF
                FAlt = 0
                IF Toets < 0 THEN
                    FOR X = 1 TO 26 '(A-Z)
                        IF -ASC(MID$(AltCodes, X, 1)) + 20 = Toets THEN Toets = X + 64: FAlt = -1: EXIT FOR
                    NEXT X
                END IF
                IF Toets < 0 OR Toets > 255 THEN Toets = 0
                Toets = ASC(UCASE$(CHR$(Toets)))
                IF MenuOpen THEN
                    FOR X = 1 TO INT(Menu(HorChoice, 0).MType / 256)
                        P = INSTR(Menu(HorChoice, X).Text, "&")
                        IF P THEN
                            IF ASC(UCASE$(MID$(Menu(HorChoice, X).Text, P + 1))) = Toets THEN
                                VerChoice = X
                                IF (Menu(HorChoice, X).MType AND 1) = 0 THEN
                                    CloseWin Background()
                                    EXIT DO
                                END IF
                            END IF
                        END IF
                    NEXT X
                    IF In.Pieptoon THEN PLAY "O3L63AE"
                ELSE
                    FOR X = 1 TO MaxChoice
                        P = INSTR(Menu(X, 0).Text, "&")
                        IF P THEN
                            IF ASC(UCASE$(MID$(Menu(X, 0).Text, P + 1))) = Toets THEN
                                HorChoice = X
                                IF Menu(HorChoice, 0).MType AND 1 THEN IF In.Pieptoon THEN PLAY "O3L63AE"
                                GOSUB Submenu
                                EXIT FOR
                            END IF
                        END IF
                    NEXT X
                END IF
        END SELECT

        IF LHorChoice <> HorChoice THEN
            IF LHorChoice > 0 THEN
                MK = MenuKol
                FOR X = 1 TO LHorChoice - 1
                    MK = MK + LEN(RTRIM$(Menu(X, 0).Text)) + 1
                NEXT X
                L = LEN(RTRIM$(Menu(LHorChoice, 0).Text)) + 1
                IF Menu(LHorChoice, 0).MType AND 1 THEN
                    QATTR MenuRij, MK, 1, L, (Kleur(18) MOD 16) + (Kleur(4) AND 240)
                ELSE
                    QATTR MenuRij, MK, 1, L, Kleur(4)
                    P = INSTR(Menu(LHorChoice, 0).Text, "&")
                    IF P > 0 AND MenuOpen = 0 THEN
                        QATTR MenuRij, MK + P, 1, 1, Kleur(5)
                    END IF
                END IF
            END IF
            IF HorChoice > 0 THEN
                MK = MenuKol
                FOR X = 1 TO HorChoice - 1
                    MK = MK + LEN(RTRIM$(Menu(X, 0).Text)) + 1
                NEXT X
                L = LEN(RTRIM$(Menu(HorChoice, 0).Text)) + 1
                IF Menu(HorChoice, 0).MType AND 1 THEN
                    QATTR MenuRij, MK, 1, L, (Kleur(18) MOD 16) + (Kleur(6) AND 240)
                ELSE
                    QATTR MenuRij, MK, 1, L, Kleur(6)
                    P = INSTR(Menu(HorChoice, 0).Text, "&")
                    IF P > 0 AND MenuOpen = 0 THEN
                        QATTR MenuRij, MK + P, 1, 1, Kleur(7)
                    END IF
                END IF
            END IF
            IF MenuOpen = 0 THEN QPRINT Menu(HorChoice, 0).MsgLine, In.Rijen, 1, Kleur(19)
            LHorChoice = HorChoice
        END IF

        IF LVerChoice <> VerChoice AND MenuOpen > 0 THEN
            IF LVerChoice > 0 THEN
                IF Menu(HorChoice, LVerChoice).MType AND 1 THEN
                    QATTR LVerChoice + MenuRij + 1, BoxKol + 1, 1, MBreedte + 2, (Kleur(18) MOD 16) + (Kleur(4) AND 240)
                ELSE
                    QATTR LVerChoice + MenuRij + 1, BoxKol + 1, 1, MBreedte + 2, Kleur(4)
                    P = INSTR(Menu(HorChoice, LVerChoice).Text, "&")
                    IF P THEN
                        QATTR LVerChoice + MenuRij + 1, BoxKol + P + 1, 1, 1, Kleur(5)
                    END IF
                END IF
            END IF
            IF VerChoice > 0 THEN
                IF Menu(HorChoice, VerChoice).MType AND 1 THEN
                    QATTR VerChoice + MenuRij + 1, BoxKol + 1, 1, MBreedte + 2, (Kleur(18) MOD 16) + (Kleur(6) AND 240)
                ELSE
                    QATTR VerChoice + MenuRij + 1, BoxKol + 1, 1, MBreedte + 2, Kleur(6)
                    P = INSTR(Menu(HorChoice, VerChoice).Text, "&")
                    IF P THEN
                        QATTR VerChoice + MenuRij + 1, BoxKol + P + 1, 1, 1, Kleur(7)
                    END IF
                END IF
            END IF
            IF HorChoice > 0 THEN
                QPRINT Menu(HorChoice, VerChoice).MsgLine, In.Rijen, 1, Kleur(19)
            ELSE
                QPRINT Menu(0, 0).MsgLine, In.Rijen, 1, Kleur(19)
            END IF
            LVerChoice = VerChoice
        END IF
    LOOP
    QPRINT Menu(0, 0).MsgLine, In.Rijen, 1, Kleur(19)
    IF Visible THEN LOCATE , , 1
    EXIT SUB

Menubalk:
    MK = MenuKol
    FOR X = 1 TO MaxChoice
        P = INSTR(Menu(X, 0).Text, "&")
        IF FirstTime THEN
            M$ = RTRIM$(Menu(X, 0).Text)
            IF P THEN M$ = LEFT$(M$, P - 1) + MID$(M$, P + 1)
            IF Menu(X, 0).MType AND 1 THEN
                QPRINT " " + M$ + " ", MenuRij, MK, (Kleur(18) MOD 16) + (Kleur(4) AND 240)
            ELSE
                QPRINT " " + M$ + " ", MenuRij, MK, Kleur(4)
            END IF
        END IF
        P = INSTR(Menu(X, 0).Text, "&")
        IF P > 0 AND (Menu(X, 0).MType AND 1) = 0 THEN
            IF X = HorChoice THEN
                IF MenuOpen = 0 THEN
                    QATTR MenuRij, MK + P, 1, 1, Kleur(7)
                ELSE
                    QATTR MenuRij, MK + P, 1, 1, Kleur(6)
                END IF
            ELSE
                IF MenuOpen = 0 THEN
                    QATTR MenuRij, MK + P, 1, 1, Kleur(5)
                ELSE
                    QATTR MenuRij, MK + P, 1, 1, Kleur(4)
                END IF
            END IF
        END IF
        MK = MK + LEN(RTRIM$(Menu(X, 0).Text)) + 1
    NEXT X
    FirstTime = 0
    RETURN

Submenu:
    VerChoice = 1
    F = 0
    WHILE Menu(HorChoice, VerChoice).MType AND 2
        VerChoice = VerChoice + 1
    WEND
    LVerChoice = 0
    IF MenuOpen THEN
        CloseWin Background()
        LMouseClick = 0
    ELSE
        MenuOpen = -1
        IF (Menu(HorChoice, 0).MType AND 1) = 0 THEN GOSUB Menubalk
    END IF
    IF Menu(HorChoice, 0).MType AND 1 THEN
        MenuOpen = 0
        IF LHorChoice <> HorChoice THEN GOSUB Menubalk
        RETURN
    END IF
    MenuOpen = HorChoice
    MBreedte = 0
    FOR X = 1 TO INT(Menu(HorChoice, 0).MType / 256)
        IF LEN(STRIP(Menu(HorChoice, X).Text)) - 1 > MBreedte THEN MBreedte = LEN(RTRIM$(Menu(HorChoice, X).Text)) - 1
    NEXT X
    MK = MenuKol
    FOR X = 1 TO HorChoice - 1
        MK = MK + LEN(RTRIM$(Menu(X, 0).Text)) + 1
    NEXT X
    BoxKol = MK - 1
    IF BoxKol + MBreedte + 4 > 79 THEN BoxKol = 79 - MBreedte - 4
    OpenWin MenuRij + 1, BoxKol, INT(Menu(HorChoice, 0).MType / 256) + 2, MBreedte + 4, Kleur(4), FRM, In.Schaduw, 0, "", Background()
    FOR X = 1 TO INT(Menu(HorChoice, 0).MType / 256)
        P = INSTR(Menu(HorChoice, X).Text, "&")
        M$ = RTRIM$(Menu(HorChoice, X).Text)
        IF P THEN M$ = LEFT$(M$, P - 1) + MID$(M$, P + 1)
        IF Menu(HorChoice, X).MType AND 1 THEN
            QPRINT " " + M$ + " ", X + MenuRij + 1, BoxKol + 1, (Kleur(18) MOD 16) + (Kleur(4) AND 240)
        ELSEIF Menu(HorChoice, X).MType AND 2 THEN
            QPRINT "" + STRING$(MBreedte + 2, "") + "", X + MenuRij + 1, BoxKol + 1 - 1, Kleur(4)
        ELSEIF Menu(HorChoice, X).MType AND 4 THEN
            QPRINT "" + M$ + " ", X + MenuRij + 1, BoxKol + 1, Kleur(4)
            IF P THEN
                QATTR X + MenuRij + 1, BoxKol + 1 + P, 1, 1, Kleur(5)
            END IF
        ELSE
            QPRINT M$, X + MenuRij + 1, BoxKol + 2, Kleur(4)
            IF P THEN
                QATTR X + MenuRij + 1, BoxKol + 1 + P, 1, 1, Kleur(5)
            END IF
        END IF
    NEXT X
    RETURN
END SUB

FUNCTION SelectieBox (Title$, Choice$(), SelectieSwitch(), Aantal, HelpTpcNum)
    REDIM SW(1 TO In.Rijen - 5), Background(0)
    FOR X = 1 TO Aantal
        IF LEN(Choice$(X)) > Breedte THEN Breedte = LEN(Choice$(X))
        SW(X) = (SelectieSwitch(X) AND 256) = 256
    NEXT X
    IF Breedte < 39 THEN Breedte = 39
    Breedte = Breedte + 5
    VRij = (In.Rijen - Aantal - 5) \ 2   'Locatie van het venster
    VKol = (78 - Breedte) \ 2
    OpenWin VRij, VKol, Aantal + 5, Breedte + 2, Kleur(8), 2, In.Schaduw, Kleur(15), Title$, Background()
    QPRINT "F1=Help  Enter=Uitvoeren  Esc=Annuleren  Tab=Volgende veld  Pijl=Volgende item  ", In.Rijen, 1, Kleur(19)
    Choice = 1
    REDIM CTS(0 TO 1) AS STRING * 3, CT(0 TO 1) AS STRING * 3
    CTS(0) = "()"
    CT(0) = "( )"
    CTS(1) = "[X]"
    CT(1) = "[ ]"
    FOR X = 1 TO Aantal
        IF SelectieSwitch(X) AND 1024 THEN
            QPRINT "" + STRING$(Breedte, 196) + "", X + VRij, VKol, Kleur(8)
        ELSEIF SelectieSwitch(X) AND 512 THEN
            QPRINT Choice$(X), X + VRij, VKol + 6, (Kleur(18) MOD 16) + (Kleur(8) AND 240)
        ELSE
            QPRINT Choice$(X), X + VRij, VKol + 6, Kleur(8)
        END IF
    NEXT X
    Default = 1
    ButtonType = 1
    SelButton$ = SelectButton(VRij + Aantal + 2, VKol + Breedte \ 2 - 21, VRij, VKol, ButtonType + 2048, MRij, MKol, Toets)
    DO
        SELECT CASE Default
            CASE 1
                IF LastChoice <> Choice THEN
                    FOR X = 1 TO Aantal
                        IF (SelectieSwitch(X) AND 1024) = 0 THEN
                            IF SW(X) THEN S$ = CTS(SelectieSwitch(X) MOD 256) ELSE S$ = CT(SelectieSwitch(X) MOD 256)
                            QPRINT S$, X + VRij, VKol + 2, Kleur(16)
                            IF X = Choice THEN
                                IF Toets = 257 THEN
                                    LOCATE , , 0
                                ELSE
                                    LOCATE X + VRij, VKol + 3, 1
                                END IF
                                IF SelectieSwitch(X) AND 512 THEN
                                    QATTR X + VRij, VKol + 2, 1, 3, (Kleur(18) MOD 16) + (Kleur(17) AND 240)
                                ELSE
                                    QATTR X + VRij, VKol + 2, 1, 3, Kleur(17)
                                END IF
                            ELSEIF SelectieSwitch(X) AND 512 THEN
                                QATTR X + VRij, VKol + 2, 1, 3, (Kleur(18) MOD 16) + Kleur(16) - (Kleur(16) MOD 16)
                            END IF
                        END IF
                    NEXT X
                    LastChoice = Choice
                END IF
                Toets = UserInput(MRij, MKol, 0, 0, 0, 0)
            CASE 2
                SelButton$ = SelectButton(VRij + Aantal + 2, VKol + Breedte \ 2 - 21, VRij, VKol, ButtonType, MRij, MKol, Toets)
        END SELECT
        SELECT CASE Toets
            CASE 9
                Default = Default + 1
                IF Default > 2 THEN Default = 1
                IF Default = 1 THEN LastChoice = 0
            CASE -15
                Default = Default - 1
                IF Default < 1 THEN Default = 2
                IF Default = 1 THEN LastChoice = 0
            CASE -80, -77
                IF Default = 1 THEN
                    IF Choice < Aantal THEN Choice = Choice + 1 ELSE Choice = 1
                    IF SelectieSwitch(Choice) AND 1024 THEN Choice = Choice + 1
                END IF
            CASE -72, -75
                IF Default = 1 THEN
                    IF Choice > 1 THEN Choice = Choice - 1 ELSE Choice = Aantal
                    IF SelectieSwitch(Choice) AND 1024 THEN Choice = Choice - 1
                END IF
            CASE 27
                Escaped = -1
                EXIT DO
            CASE 32, 13
                IF Default = 1 THEN
                    IF (SelectieSwitch(Choice) AND 512) = 0 THEN
                        IF SelectieSwitch(Choice) MOD 256 = 0 THEN
                            C = Choice
                            DO
                                SW(C) = 0
                                C = C - 1
                                IF C < 1 THEN EXIT DO
                            LOOP UNTIL SelectieSwitch(C) MOD 256 OR ((SelectieSwitch(C) AND 1024) = 1024)
                            C = Choice
                            DO
                                SW(C) = 0
                                C = C + 1
                                IF C > Aantal THEN EXIT DO
                            LOOP UNTIL SelectieSwitch(C) MOD 256 OR ((SelectieSwitch(C) AND 1024) = 1024)
                        END IF
                        SW(Choice) = NOT SW(Choice)
                    ELSEIF In.Pieptoon THEN
                        PLAY "O3L63AE"
                    END IF
                    LastChoice = 0
                END IF
            CASE 256, 260
                Default = 2
                IF Default = 1 THEN LastChoice = 0
                Ingedrukt = 0
                FOR X = 1 TO Aantal
                    IF MRij = X + VRij AND (MKol >= VKol + 2 AND MKol <= VKol + LEN(S$) + 1) AND (SelectieSwitch(X) AND 1024) = 0 THEN
                        Choice = X
                        Default = 1
                        EXIT FOR
                    END IF
                NEXT X
            CASE 257
                Ingedrukt = 0
                IF Default = 1 THEN
                    FOR X = 1 TO Aantal
                        IF MRij = X + VRij AND (MKol >= VKol + 2 AND MKol <= VKol + LEN(S$) + 1) AND (SelectieSwitch(X) AND 1024) = 0 THEN
                            Choice = X
                            Ingedrukt = -1
                        END IF
                    NEXT X
                END IF
            CASE 258
                IF Default = 1 AND Ingedrukt THEN
                    IF (SelectieSwitch(Choice) AND 512) = 0 THEN
                        IF SelectieSwitch(Choice) MOD 256 = 0 THEN
                            C = Choice
                            DO
                                SW(C) = 0
                                C = C - 1
                                IF C < 1 THEN EXIT DO
                            LOOP UNTIL SelectieSwitch(C) MOD 256 OR ((SelectieSwitch(C) AND 1024) = 1024)
                            C = Choice
                            DO
                                SW(C) = 0
                                C = C + 1
                                IF C > Aantal THEN EXIT DO
                            LOOP UNTIL SelectieSwitch(C) MOD 256 OR ((SelectieSwitch(C) AND 1024) = 1024)
                        END IF
                        SW(Choice) = NOT SW(Choice)
                    ELSEIF In.Pieptoon THEN
                        PLAY "O3L63AE"
                    END IF
                    LastChoice = 0
                END IF
                LastChoice = 0
            CASE -59
                HelpWindow HelpTpcNum
                QPRINT "F1=Help  Enter=Uitvoeren  Esc=Annuleren  Tab=Volgende veld  Pijl=Volgende item  ", In.Rijen, 1, Kleur(19)
            CASE 0
                SELECT CASE SelButton$
                    CASE "OK"
                        EXIT DO
                    CASE "ANNULEREN"
                        Escaped = -1
                        EXIT DO
                    CASE "HELP"
                        HelpWindow HelpTpcNum
                        QPRINT "F1=Help  Enter=Uitvoeren  Esc=Annuleren  Tab=Volgende veld  Pijl=Volgende item  ", In.Rijen, 1, Kleur(19)
                    CASE ELSE
                END SELECT
        END SELECT
    LOOP
    IF NOT Escaped THEN
        FOR X = 1 TO Aantal
            SelectieSwitch(X) = SW(X)
        NEXT X
    END IF
    SelectieBox = NOT Escaped
    CloseWin Background()
    QPRINT SPACE$(80), In.Rijen, 1, Kleur(19)
END FUNCTION

