DECLARE SUB SetInitValue (Var AS STRING, Value AS STRING)
DECLARE SUB LoadInitFile ()
DECLARE FUNCTION GetInitValue$ (Var AS STRING, LineNum%)
DECLARE FUNCTION STRIP$ (St$)
DECLARE FUNCTION GetSelection% (SelArray%(), Aantal%)
DECLARE SUB Onderbreking (ExitKey%, Msg$)
DECLARE SUB OpenWin (Row%, Col%, Hght%, Wdth%, Attr%, Frm%, Shadow%, Label%, Label$, Background%())
DECLARE SUB CloseWin (Background%())
DECLARE FUNCTION MSGBox$ (Msg$, ButtonType%, Title$, HelpTpcNum%)
DECLARE FUNCTION InputBox$ (Title$, Msg$, InString$, Legal$, Length%, Visible%, HotKey%, HelpTpcNum%)
DECLARE FUNCTION BesInvoer% (BesNaam$, InputExt$, Msg$, Titel$)
DECLARE FUNCTION OpslaanAls% (InputNaam$, InputExt$)
DECLARE FUNCTION Klank$ (Woord$)
DECLARE SUB InOpslaan ()
DECLARE SUB QPRINT (Text AS STRING, Row AS INTEGER, Col AS INTEGER, Attr AS INTEGER)
DECLARE SUB QATTR (Row AS INTEGER, Col AS INTEGER, Rows AS INTEGER, Cols AS INTEGER, Attr AS INTEGER)
DECLARE SUB ClrScrn ()
DECLARE FUNCTION UserInput% (MRij%, MKol%, Shift%, Ctrl%, Alt%, ErUitNa!)
DECLARE FUNCTION SelectieBox% (Title$, Choice$(), SelectieSwitch%(), Aantal%, HelpTpcNum%)
DEFINT A-Z
'PBCLONE
DECLARE FUNCTION GetPSP% ()
DECLARE SUB Blink (BYVAL SetBlink%)
DECLARE SUB CursorInfo (Visible%, StartLine%, EndLine%, MaxLine%)
DECLARE SUB DelayV (BYVAL MilliSeconds%)
DECLARE FUNCTION Exist2% (FileName$)
DECLARE SUB Extract (St$, Delimiter$, Index%, Start%, SLen%)
DECLARE SUB FileCount (File$, BYVAL FilAttr%, FilCount%, ErrCode%)
DECLARE FUNCTION GetCRT2% ()
DECLARE FUNCTION GetDrive$ ()
DECLARE FUNCTION GetEGA2% ()
DECLARE SUB GetKbd (Ins%, Caps%, Num%, ScrollLock%)
DECLARE SUB GetKbd1 (LShift%, RShift%, Control%, Alt%)
DECLARE SUB GetMouseLoc (Row%, Column%)
DECLARE SUB GetScreen (Array%(), BYVAL TopRow%, BYVAL LeftCol%, BYVAL BotRow%, BYVAL RtCol%, BYVAL Page%, BYVAL Fast%)
DECLARE FUNCTION GetSub2$ (Drive$)
DECLARE FUNCTION GetVGA2% ()
DECLARE SUB LoadDir (File$, BYVAL FilAttr%, BYVAL DSeg%, BYVAL DOfs%, ErrCode%)
DECLARE SUB MMButton (LeftB%, RightB%)
DECLARE FUNCTION MMCheck2% ()
DECLARE SUB MMCursorOff ()
DECLARE SUB MMCursorOn ()
DECLARE SUB MMSetRange (BYVAL X1%, BYVAL Y1%, BYVAL X2%, BYVAL Y2%)
DECLARE SUB RInstr (MainSt$, SubSt$, Posn%)
DECLARE SUB SetBit (Number%, BYVAL BitNr%)
DECLARE SUB SetDrv (Drive$)
DECLARE SUB SetLogiDrive (Drive$, ErrCode%)
DECLARE SUB SetSub (SubDir$, ErrCode%)
DECLARE FUNCTION SubExist2% (SubDir$)
TYPE InitVars
    Rijen AS INTEGER
    Muis AS INTEGER
    AutoSave AS INTEGER
    Pieptoon AS INTEGER
    Schaduw AS INTEGER
    BeeldAfTijd AS INTEGER
    TekstSnel AS INTEGER
    RegelsAutomatisch AS INTEGER
END TYPE
DIM Kleur(1 TO 19)
COMMON SHARED Kleur()
COMMON SHARED In AS InitVars, HelpFile$
COMMON SHARED HoofdLettercontrole, Eensynoniem, MaxAantalWoorden
DIM SHARED InitFile$, DoorgaanMetAfdrukken
DIM InitLine(1 TO 255) AS STRING, InitLines AS INTEGER

BeeldAfTijd:
QPRINT TIME$, 1, 72, Kleur(4)
RETURN

ApparaatFout:
T$ = MSGBox("Fout bij schrijven naar het apparaat", 5, "Fout", 0)
SELECT CASE T$
    CASE "ANNULEREN"
        DoorgaanMetAfdrukken = 0
        RESUME NEXT
    CASE ELSE
        RESUME
END SELECT

EscapeIngedrukt:
T$ = MSGBox("Weet je zeker dat je het afdrukken wilt stoppen?", 4, "Afdrukken", 0)
SELECT CASE T$
    CASE "JA"
        DoorgaanMetAfdrukken = 0
END SELECT
RETURN

SUB Afdrukken (Kolom1$(), Kolom2$(), Aantal, FirstLine$)
    KEY 15, CHR$(&H0) + CHR$(&H1)
    ON KEY(15) GOSUB EscapeIngedrukt
    REDIM SelectieSwitch(1 TO 7), Choice$(1 TO 7)
    Choice$(1) = "Scherm"
    Choice$(2) = "COM1"
    Choice$(3) = "COM2"
    Choice$(4) = "LPT1"
    Choice$(5) = "LPT2"
    Choice$(6) = "LPT3"
    Choice$(7) = "Bestand"
    SelectieSwitch(4) = 256
    QPRINT "Selecteer het apparaat waar de gegevens naar toe moeten worden gestuurd", In.Rijen, 1, Kleur(19)
    OK = SelectieBox("Afdrukken", Choice$(), SelectieSwitch(), 7, 10)
    FOR X = 1 TO 6
        IF SelectieSwitch(X) THEN
            Apparaat$ = MID$("SCRN:COM1:COM2:LPT1:LPT2:LPT3:", X * 5 - 4, 5)
            EXIT FOR
        END IF
    NEXT X
    IF SelectieSwitch(7) AND OK THEN
        Apparaat$ = "OUTPUT.TXT"
        Text$ = "Naam:|Voer de naam van het bestand in,|waarnaar je de gegevens toe wilt sturen.|In de naam mag ook een directory voorkomen."
        OK = BesInvoer(Apparaat$, "", Text$, "Afdrukken")
    END IF
    IF OK THEN
        ERASE SelectieSwitch, Choice$
        DoorgaanMetAfdrukken = -1
        ON ERROR GOTO ApparaatFout
        OPEN Apparaat$ FOR OUTPUT AS #1
        KEY(15) ON
        IF Apparaat$ = "SCRN:" THEN
            REDIM Background(0)
            IF In.BeeldAfTijd THEN TIMER STOP
            IF In.Muis THEN MMCursorOff
            OpenWin 1, 1, In.Rijen - 1, 80, 7, 0, 0, 0, "", Background()
            LOCATE , , 0
            VIEW PRINT 1 TO In.Rijen - 1
        ELSE
            QPRINT SPACE$(80), In.Rijen, 1, Kleur(19)
            QPRINT "ESC=Stoppen  Bezig met de informatie naar het apparaat te sturen", In.Rijen, 1, Kleur(19)
        END IF
  'Titel neerplanten
        IF DoorgaanMetAfdrukken THEN PRINT #1, TAB(40 - LEN(FirstLine$) \ 2); FirstLine$
  'Naam kolommen neerzetten
        W1$ = Kolom1$(1)
        W2$ = Kolom2$(1)
        IF DoorgaanMetAfdrukken THEN PRINT #1, TAB(20 - LEN(W1$) \ 2); W1$;
        IF DoorgaanMetAfdrukken THEN PRINT #1, TAB(60 - LEN(W2$) \ 2); W2$
        X = 1
        DO UNTIL (X = Aantal AND WL1$ = "" AND WL2$ = "")
            IF LEN(WL1$) OR LEN(WL2$) THEN
                IF LEN(WL1$) > 39 THEN
                    W1$ = LEFT$(WL1$, 39)
                    WL1$ = RIGHT$(WL1$, LEN(WL1$) - 39)
                ELSE
                    W1$ = WL1$ + SPACE$(39 - LEN(WL1$))
                    WL1$ = ""
                END IF
                IF LEN(WL2$) > 39 THEN
                    W2$ = LEFT$(WL2$, 39)
                    WL2$ = RIGHT$(WL2$, LEN(WL2$) - 39)
                ELSE
                    W2$ = WL2$ + SPACE$(39 - LEN(WL2$))
                    WL2$ = ""
                END IF
            ELSE
                X = X + 1
                W1$ = Kolom1$(X)
                W2$ = Kolom2$(X)
                IF LEN(W1$) > 39 THEN
                    WL1$ = RIGHT$(W1$, LEN(W1$) - 39)
                    W1$ = LEFT$(W1$, 39)
                ELSE
                    WL1$ = ""
                    W1$ = W1$ + SPACE$(39 - LEN(W1$))
                END IF
                IF LEN(W2$) > 39 THEN
                    WL2$ = RIGHT$(W2$, LEN(W2$) - 39)
                    W2$ = LEFT$(W2$, 39)
                ELSE
                    WL2$ = ""
                    W2$ = W2$ + SPACE$(39 - LEN(W2$))
                END IF
            END IF
            IF DoorgaanMetAfdrukken THEN PRINT #1, USING "\" + SPACE$(37) + "\\" + SPACE$(37) + "\"; W1$; W2$
            IF CSRLIN = 24 AND Apparaat$ = "SCRN:" AND DoorgaanMetAfdrukken THEN
                Onderbreking -1, ""
                CLS
            END IF
        LOOP
        KEY(15) OFF
        CLOSE #1
        IF NOT DoorgaanMetAfdrukken THEN
            IF In.Pieptoon THEN PLAY "O3L63AE"
            Onderbreking KH, "Afdrukken is geannuleerd"
        END IF
        IF Apparaat$ = "SCRN:" THEN
            IF DoorgaanMetAfdrukken THEN Onderbreking -1, ""
            CloseWin Background()
            VIEW PRINT
            IF In.BeeldAfTijd THEN TIMER ON
            IF In.Muis THEN MMCursorOn
        END IF
    END IF
END SUB

SUB ClrScrn 'Scherm schoon maken/instellen
    WIDTH 80, In.Rijen
    MMSetRange 0, 0, 632, In.Rijen * 8 - 8
    Blink 0
    LOCATE , , 0
    QPRINT SPACE$(80), 1, 1, Kleur(4)
    IF In.BeeldAfTijd THEN QPRINT TIME$, 1, 72, Kleur(4)
    IF In.Muis THEN MMCursorOff
    QPRINT STRING$(80 * (In.Rijen - 2), 176), 2, 1, Kleur(1)
    IF In.Muis THEN MMCursorOn
    QPRINT SPACE$(80), In.Rijen, 1, Kleur(19)
END SUB

SUB Einde
    ON ERROR GOTO 0
    IF In.Muis THEN MMCursorOff
    IF In.BeeldAfTijd THEN TIMER OFF
    IF NOT In.AutoSave THEN
        LoadInitFile
        V$ = GetInitValue("AutoInstellingenOpslaan", LN)
        IF LN THEN In.AutoSave = (VAL(V$) <> 0)
        IF In.AutoSave THEN In.AutoSave = 0: InOpslaan
    ELSE
        InOpslaan
    END IF
    WIDTH 80, 25
    CLS
    Blink 1
    PRINT "*** Einde overhoor ***"
    SYSTEM
END SUB

FUNCTION GetInitValue$ (Var AS STRING, LineNum)
SHARED InitLine() AS STRING, InitLines AS INTEGER

LineNum = 0
FOR X = 1 TO InitLines
    Extract InitLine(X), ";", 1, Start, SLen
    L$ = UCASE$(LTRIM$(RTRIM$(LEFT$(InitLine(X), SLen))))
    Extract L$, "=", 1, Start, SLen
    V$ = RTRIM$(MID$(L$, Start, SLen))
    Extract L$, "=", 2, Start, SLen
    Value$ = RTRIM$(MID$(L$, Start, SLen))
    IF V$ = UCASE$(Var) THEN GetInitValue$ = Value$: LineNum = X
NEXT X
END FUNCTION

FUNCTION GetSelection (SelArray(), Aantal)
    MaxWoord = Aantal
    DO
        Text$ = "Welke:|"
        Text$ = Text$ + "Voer in welke regels overhoord|"
        Text$ = Text$ + "moeten worden"
        Legal$ = "12345678910,[]{}"
        Bereik$ = LTRIM$(RTRIM$(InputBox("Overhoren", Text$, "[1," + STR$(MaxWoord) + "]", Legal$, 50, 25, HK, 38)))
        IF LEFT$(Bereik$, 1) = "{" THEN
            IF RIGHT$(Bereik$, 1) <> "}" THEN Bereik$ = Bereik$ + "}"
        ELSEIF LEFT$(Bereik$, 1) = "[" THEN
            IF RIGHT$(Bereik$, 1) <> "]" THEN Bereik$ = Bereik$ + "]"
        END IF
        FouteInvoer = 0
        IF HK = 1 THEN GetSelection = 0: EXIT FUNCTION
        IF LEN(Bereik$) >= 2 THEN
            B$ = MID$(Bereik$, 2, LEN(Bereik$) - 2)
            DO UNTIL B$ = ""
                P = INSTR(B$, ",")
                IF P THEN
                    Q = VAL(LEFT$(B$, P - 1))
                    B$ = MID$(B$, P + 1)
                ELSE
                    Q = VAL(B$)
                    B$ = ""
                END IF
                IF Q < 0 OR Q > MaxWoord THEN
                    IF In.Pieptoon THEN PLAY "O3L63AE"
                    FouteInvoer = -1
                    EXIT DO
                END IF
            LOOP
        ELSE
            IF In.Pieptoon THEN PLAY "O3L63AE"
            FouteInvoer = -1
        END IF
        IF NOT FouteInvoer THEN
            B$ = MID$(Bereik$, 2, LEN(Bereik$) - 2)
            DO UNTIL B$ = ""
                P = INSTR(B$, ",")
                IF P THEN
                    Q = VAL(LEFT$(B$, P - 1))
                    B$ = MID$(B$, P + 1)
                ELSE
                    Q = VAL(B$)
                    B$ = ""
                END IF
                IF Q < 0 OR Q > MaxWoord THEN
                    IF In.Pieptoon THEN PLAY "O3L63AE"
                    FouteInvoer = -1
                    EXIT DO
                END IF
            LOOP
        END IF
    LOOP WHILE FouteInvoer
    GetSelection = -1
    IF LEN(Bereik$) THEN
        B$ = LEFT$(Bereik$, LEN(Bereik$) - 1) + ", "
    ELSE
        B$ = ""
    END IF
    QPRINT "Even wachten alsjeblieft", In.Rijen, 1, Kleur(19)
    Aantal = 0
    FOR X = 1 TO MaxWoord
        IF LEFT$(B$, 1) = "[" THEN
            IF X >= VAL(MID$(B$, 2, INSTR(B$, ",") - 2)) AND X <= VAL(MID$(B$, INSTR(B$, ",") + 1, LEN(B$) - INSTR(B$, ",") - 1)) THEN
                Aantal = Aantal + 1
                SelArray(Aantal) = X
            END IF
        ELSEIF LEFT$(B$, 1) = "{" THEN
            IF INSTR(B$, LTRIM$(STR$(X)) + ",") THEN
                Aantal = Aantal + 1
                SelArray(Aantal) = X
            END IF
        ELSEIF B$ = "" THEN
            Aantal = Aantal + 1
            SelArray(Aantal) = X
        END IF
    NEXT X
END FUNCTION

SUB Init 'Overhoor initializeren
SHARED MuisAanwezig
MuisAanwezig = MMCheck2 > 0 'Dat checken voor mouse gaat wat langzaam
IF GetCRT2 THEN             'en doe ik daarom maar n keer
    Kleur(1) = 135
    Kleur(2) = 159
    Kleur(3) = 240
    Kleur(4) = 240
    Kleur(5) = 244
    Kleur(6) = 15
    Kleur(7) = 4
    Kleur(8) = 176
    Kleur(9) = 159
    Kleur(10) = 31
    Kleur(11) = 32
    Kleur(12) = 46
    Kleur(13) = 47
    Kleur(14) = 15
    Kleur(15) = 240
    Kleur(16) = 112
    Kleur(17) = 240
    Kleur(18) = 120
    Kleur(19) = 135
    In.Schaduw = -1
ELSE
    Kleur(1) = 7
    Kleur(2) = 7
    Kleur(3) = 112
    Kleur(4) = 240
    Kleur(5) = 151
    Kleur(6) = 15
    Kleur(7) = 240
    Kleur(8) = 112
    Kleur(9) = 7
    Kleur(10) = 9
    Kleur(11) = 7
    Kleur(12) = 15
    Kleur(13) = 1
    Kleur(14) = 9
    Kleur(15) = 9
    Kleur(15) = 15
    Kleur(16) = 112
    Kleur(17) = 7
    Kleur(18) = 120
    Kleur(19) = 112
    In.Schaduw = 0
END IF
In.BeeldAfTijd = -1
In.Pieptoon = -1
In.Rijen = 25
In.Muis = MuisAanwezig
In.TekstSnel = GetVGA2 OR GetEGA2
In.AutoSave = -1

'Overhoor path bepalen
DEF SEG = GetPSP
Segment% = (256 * PEEK(&H2D)) + PEEK(&H2C)
DEF SEG = Segment%
Byte% = 0
DO
  X% = PEEK(Byte%)
  IF X% = 0 THEN
    IF PEEK(Byte% + 1) = 0 THEN StartPath% = Byte% + 2: EXIT DO
  END IF
  Byte% = Byte% + 1
LOOP
Vervolg% = PEEK(StartPath%) + (256 * PEEK(StartPath% + 1))
Byte% = StartPath% + 2
Path$ = ""
DO
  P% = PEEK(Byte%)
  IF P% = 0 THEN EXIT DO ELSE Path$ = Path$ + CHR$(P%)
  Byte% = Byte% + 1
LOOP
DEF SEG
RInstr Path$, "\", P
Path$ = LEFT$(Path$, P)
HelpFile$ = Path$ + "OVERHOOR.HLP"
InitFile$ = Path$ + "OVERHOOR.INI"

MaxAantalWoorden = 500

LoadInitFile

V$ = GetInitValue("Kleuren", LN)
IF LN THEN
    FOR X = 1 TO 18
        Extract V$, ",", X, Start, SLen
        Kleur(X) = VAL(MID$(V$, Start, SLen))
    NEXT X
END IF
   
V$ = GetInitValue("TekstViaBios", LN)
IF LN THEN In.TekstSnel = NOT (VAL(V$) <> 0)
   
V$ = GetInitValue("Tijd", LN)
IF LN THEN In.BeeldAfTijd = (VAL(V$) <> 0)
   
V$ = GetInitValue("Schaduw", LN)
IF LN THEN In.Schaduw = (VAL(V$) <> 0)
   
V$ = GetInitValue("Pieptoon", LN)
IF LN THEN In.Pieptoon = (VAL(V$) <> 0)
   
V$ = GetInitValue("AutoInstellingenOpslaan", LN)
IF LN THEN In.AutoSave = (VAL(V$) <> 0)
   
V$ = GetInitValue("Muis", LN)
IF LN THEN In.Muis = (VAL(V$) <> 0)
          
V$ = GetInitValue("Regels", LN)
IF LN THEN
    IF V$ = "AUTO" THEN
        IF GetVGA2 THEN
            In.Rijen = 50
        ELSEIF GetEGA2 THEN
            In.Rijen = 43
        ELSE
            In.Rijen = 25
        END IF
        In.RegelsAutomatisch = -1
    ELSE
        In.Rijen = VAL(V$)
        IF In.Rijen <> 50 AND In.Rijen <> 43 THEN In.Rijen = 25
    END IF
END IF
   
V$ = GetInitValue("Hoofdlettercontrole", LN)
IF LN THEN HoofdLettercontrole = (VAL(V$) <> 0)
       
V$ = GetInitValue("Eensynoniem", LN)
IF LN THEN Eensynoniem = (VAL(V$) <> 0)
   
V$ = GetInitValue("MaxAantalWoorden", LN)
IF LN THEN MaxAantalWoorden = VAL(V$): IF MaxAantalWoorden < 0 THEN MaxAantalWoorden = 500

IF NOT MuisAanwezig AND In.Muis THEN
    PRINT "Muis niet beschikbaar!"
    PRINT "Je moet de mouse-driver installeren voordat je Overhoor start"
    PRINT "om de muis te gebruiken"
    BEEP
    PRINT "Druk op een toets om verder te gaan..."
    SLEEP
    In.Muis = 0
ELSEIF In.Muis THEN
    MMCursorOn
END IF
IF In.BeeldAfTijd THEN ON TIMER(1) GOSUB BeeldAfTijd
WIDTH 80, In.Rijen
Blink 0
END SUB

SUB InOpslaan
SHARED InitLine() AS STRING, InitLines AS INTEGER

FOR X = 1 TO 18
    V$ = V$ + STR$(Kleur(X)) + ","
NEXT X
V$ = V$ + STR$(Kleur(19))
SetInitValue "Kleuren", V$
SetInitValue "TekstViaBios", STR$(-(NOT In.TekstSnel))
SetInitValue "Tijd", STR$(-In.BeeldAfTijd)
SetInitValue "Schaduw", STR$(-In.Schaduw)
SetInitValue "Pieptoon", STR$(-In.Pieptoon)
SetInitValue "AutoInstellingenOpslaan", STR$(-In.AutoSave)
SetInitValue "Muis", STR$(-In.Muis)
IF In.RegelsAutomatisch THEN
    SetInitValue "Regels", " AUTO"
ELSE
    SetInitValue "Regels", STR$(In.Rijen)
END IF
SetInitValue "Hoofdlettercontrole", STR$(-HoofdLettercontrole)
SetInitValue "Eensynoniem", STR$(-Eensynoniem)
SetInitValue "MaxAantalWoorden", STR$(MaxAantalWoorden)
OPEN InitFile$ FOR OUTPUT AS #1
FOR X = 1 TO InitLines
    PRINT #1, InitLine(X)
NEXT X
CLOSE #1
END SUB

FUNCTION Klank$ (Woord$)
    DO UNTIL P = LEN(Woord$)
        P = P + 1
        A$ = MID$(LCASE$(Woord$), P, 1)
        IF INSTR("", A$) THEN
            W$ = W$ + "a"
        ELSEIF INSTR("", A$) THEN
            W$ = W$ + "c"
        ELSEIF INSTR("", A$) THEN
            W$ = W$ + "e"
        ELSEIF INSTR("", A$) THEN
            W$ = W$ + "u"
        ELSEIF INSTR("", A$) THEN
            W$ = W$ + "i"
        ELSEIF INSTR("", A$) THEN
            W$ = W$ + "o"
        ELSEIF INSTR("", A$) THEN
            W$ = W$ + "y"
        ELSEIF INSTR("", A$) THEN
            W$ = W$ + "n"
        ELSEIF INSTR("", A$) THEN
            W$ = W$ + "s"
        ELSE
            W$ = W$ + A$
        END IF
    LOOP
    Klank$ = W$
END FUNCTION

SUB LoadInitFile
SHARED InitLine() AS STRING, InitLines AS INTEGER

IF Exist2(InitFile$) THEN
    OPEN InitFile$ FOR INPUT AS #1
    DO UNTIL EOF(1)
        InitLines = InitLines + 1
        LINE INPUT #1, InitLine(InitLines)
    LOOP
    CLOSE #1
END IF
END SUB

SUB Onderbreking (ExitKey, Msg$)
    IF Msg$ = "" THEN Msg$ = "*** Druk op een toets om verder te gaan ***"
    IF NOT ExitKey = -1 THEN T! = TIMER + 3 ELSE T! = 86401
    DO
        P = P + 1
        IF P = 80 THEN P = 1
        T$ = SPACE$(P - 1) + Msg$
        IF LEN(T$) < 80 THEN T$ = T$ + SPACE$(80 - LEN(T$))
        IF LEN(T$) > 80 THEN MID$(T$, 1, LEN(T$) - 80) = RIGHT$(T$, LEN(T$) - 80)
        QPRINT T$, In.Rijen, 1, Kleur(19)
        ExitKey = UserInput(0, 0, -1, -1, -1, .07)
    LOOP UNTIL ExitKey <> 0 OR TIMER > T!
END SUB

SUB SetInitValue (Var AS STRING, Value AS STRING)
SHARED InitLine() AS STRING, InitLines AS INTEGER

V$ = GetInitValue(Var, LineNum)
IF LineNum THEN
    IF LTRIM$(V$) <> LTRIM$(UCASE$(Value)) THEN
        Extract InitLine(LineNum), ";", 2, Start, SLen
        IF Start < LEN(InitLine(LineNum)) THEN Comment$ = " ;" + MID$(InitLine(LineNum), Start)
        FSpace$ = SPACE$(LEN(InitLine(LineNum)) - LEN(LTRIM$(InitLine(LineNum))))
        InitLine(LineNum) = FSpace$ + Var + " =" + Value + Comment$
    END IF
ELSE
    InitLines = InitLines + 1
    InitLine(InitLines) = Var + " =" + Value
END IF
END SUB

SUB WijzigIn 'Instellingen wijzigen
    SHARED MuisAanwezig
    REDIM SelectieSwitch(1 TO 15), Choice$(1 TO 15)
    Choice$(1) = "Op hoofd- en kleine letters controleren"
    Choice$(2) = "Telkens maar n synoniem overhoren"

    SelectieSwitch(3) = 1024   'Horizontale lijn
    Choice$(4) = "Pieptoon uitzetten"

    SelectieSwitch(5) = 1024
    Choice$(6) = "Muis activeren"
    Choice$(7) = "Naar scherm schrijven via BIOS"
   
    Choice$(8) = "Schaduw bij vensters afbeelden"
    Choice$(9) = "Tijd afbeelden"

    SelectieSwitch(10) = 1024
    Choice$(11) = "25 regels"
    Choice$(12) = "43 regels"
    Choice$(13) = "50 regels"
    Choice$(14) = "Automatisch max. aantal regels"

    SelectieSwitch(1) = (HoofdLettercontrole AND 256) + 1     '256 zodat de optie
    SelectieSwitch(2) = (Eensynoniem AND 256) + 1     'ingeschakeld wordt
    SelectieSwitch(7) = ((NOT In.TekstSnel) AND 256) + 1
    SelectieSwitch(4) = ((NOT In.Pieptoon) AND 256) + 1
    SelectieSwitch(6) = (In.Muis AND 256) + 1     '+1 zodat meerdere
    SelectieSwitch(8) = (In.Schaduw AND 256) + 1     'opties gekozen
    SelectieSwitch(9) = (In.BeeldAfTijd AND 256) + 1     'kunnen worden
    SelectieSwitch(11) = ((In.Rijen = 25) AND NOT In.RegelsAutomatisch) AND 256
    SelectieSwitch(12) = ((In.Rijen = 43) AND NOT In.RegelsAutomatisch) AND 256
    SelectieSwitch(13) = ((In.Rijen = 50) AND NOT In.RegelsAutomatisch) AND 256
    SelectieSwitch(14) = In.RegelsAutomatisch AND 256
    IF NOT MuisAanwezig THEN SelectieSwitch(6) = 512 + 1   '+512 zodat de optie
    IF NOT GetVGA2 THEN SelectieSwitch(13) = 512      'buiten gebruik gezet
    IF NOT GetEGA2 THEN SelectieSwitch(12) = 512   'wordt
    OK = SelectieBox("Instellingen", Choice$(), SelectieSwitch(), 14, 30)
    IF In.Muis THEN MMCursorOff
    IF OK THEN
        HoofdLettercontrole = SelectieSwitch(1)
        Eensynoniem = SelectieSwitch(2)
        In.TekstSnel = NOT SelectieSwitch(7)
       
        In.Muis = SelectieSwitch(6)
        In.Pieptoon = NOT SelectieSwitch(4)
        IF SelectieSwitch(8) THEN In.Schaduw = -1 ELSE In.Schaduw = 0
        IF NOT SelectieSwitch(9) AND In.BeeldAfTijd THEN
            In.BeeldAfTijd = 0
            TIMER OFF
        ELSEIF SelectieSwitch(9) AND NOT In.BeeldAfTijd THEN
            In.BeeldAfTijd = -1
            ON TIMER(1) GOSUB BeeldAfTijd
            TIMER ON
        END IF
        In.RegelsAutomatisch = 0
        IF SelectieSwitch(14) THEN
            IF GetVGA2 THEN
                In.Rijen = 50
            ELSEIF GetEGA2 THEN
                In.Rijen = 43
            ELSE
                In.Rijen = 25
            END IF
            In.RegelsAutomatisch = -1
        ELSEIF SelectieSwitch(13) THEN
            In.Rijen = 50
        ELSEIF SelectieSwitch(12) THEN
            In.Rijen = 43
        ELSE
            In.Rijen = 25
        END IF
        ClrScrn
    END IF
    IF In.Muis THEN MMCursorOn
    ERASE SelectieSwitch, Choice$
END SUB

